Type TPartikel
	Field lifeTime:Int = 0
	Field col:Float[]
	Field posX:Float = 0
	Field posY:Float = 0
	Field ssize:Float = 2
	
	Field index:Int = 0
	
	Function Create:TPartikel(posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null) Abstract
	
	Method Draw:Int() Abstract
End Type

Type TPartikel_Blut Extends TPartikel

	Method Draw:Int()
		If Self.lifeTime < ms Then Return - 1
		
		Local diff:Int = Self.lifeTime - ms
		
		
		glColor4f(Self.col[0], Self.col[1], Self.col[2], diff / 10000.0)
		glPushMatrix()
		glTranslated(Self.posX, Self.posY, 0)
		
		Local u1:Float = 0.125 * Self.index
		Local u2:Float = 0.125 * (Self.index) + 0.125
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2f(u1, .0)
	'		glColor4f(Self.col[0], Self.col[1], Self.col[2], 1)
			glVertex2d(-Self.ssize, -Self.ssize)
			glTexCoord2f(u2, .0)
			glVertex2d(Self.ssize, -Self.ssize)
			glTexCoord2f(u1, .5)
			glVertex2d(-Self.ssize, Self.ssize)
			glTexCoord2f(u2, .5)
			glVertex2d(Self.ssize, Self.ssize)
		
		
		glEnd()
			glPopMatrix()
	End Method
	
	Function Create:TPartikel_Blut(posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null)
				'Lifetime is immer erstmal ms + 2000!
		Local part:TPartikel_Blut = New TPartikel_Blut
		
		part.lifeTime = ms + 10000
		part.ssize = ssize
		If col = Null Then col = [1.0, 1.0, 1.0]
		
		part.col = col
		
		part.index = Rand(0, 7)
		part.posX = posX
		part.posY = posY
		
		partikel.AddLast(part)
		Return part
	End Function
End Type
Type TPartikel_Spawn_location Extends TPartikel
	Field angle:Float = 0
	Field flug_angle:Float = 0
	Field speed:Float = 1.0
	Method Draw:Int()
	
		If Self.lifeTime < ms Then Return - 1
		Local diff:Int = Self.lifeTime - ms
		
		Self.posX:+(Cos(Self.flug_angle) * Self.speed / 2.0) + (Cos(Self.angle) * Self.speed)
		Self.posY:+(Sin(Self.flug_angle) * Self.speed / 2.0) + (Sin(Self.angle * Self.speed))
		
		Self.angle:+8
		
		glColor4f(Self.col[0], Self.col[1], Self.col[2], diff / 150.0)
		
		glPushMatrix()
		glTranslated(Self.posX, Self.posY, 0)
		glRotated(Self.angle, 0, 0, 1)
		Local u1:Float = 0.125 * Self.index
		Local u2:Float = 0.125 * (Self.index) + 0.125
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2f(u1, .5)
	'		glColor4f(Self.col[0], Self.col[1], Self.col[2], 1)
			glVertex2d(-Self.ssize, -Self.ssize)
			glTexCoord2f(u2, .5)
			glVertex2d(Self.ssize, -Self.ssize)
			glTexCoord2f(u1, 1)
			glVertex2d(-Self.ssize, Self.ssize)
			glTexCoord2f(u2, 1)
			glVertex2d(Self.ssize, Self.ssize)
		
		
		glEnd()
			glPopMatrix()
	End Method
	
	Function Create:TPartikel_Spawn_location(posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null)
				'Lifetime is immer erstmal ms + 2000!
		
		Local drehung:Float = 360.0 / 15.0
		Local drehung2:Float = drehung * Rand(0, 1)
				
		For Local i:Int = 0 Until 1
		Local part:TPartikel_Spawn_location = New TPartikel_Spawn_location
		
		part.lifeTime = ms + 150
		part.ssize = ssize * 2
		If col = Null Then col = [1.0, 1.0, 1.0]
		
		part.col = col
		
		part.index = 1
		part.posX = posX
		part.posY = posY

'		part.angle = drehung2
		part.angle = Rnd(0, 359)
			part.flug_angle = part.angle
		drehung2:+drehung
		
		part.speed = 2
		partikel.AddLast(part)
		Next
	'	Return part
	End Function
End Type
Type TPartikel_Spawn Extends TPartikel
	Field angle:Float = 0
	Field flug_angle:Float = 0
	Field speed:Float = 1.0
	Method Draw:Int()
		If Self.lifeTime < ms Then Return - 1
		Local diff:Int = Self.lifeTime - ms
		
		Self.posX:+(Cos(Self.flug_angle) * Self.speed / 2.0) + (Cos(Self.angle) * Self.speed)
		Self.posY:+(Sin(Self.flug_angle) * Self.speed / 2.0) + (Sin(Self.angle * Self.speed))
		
		Self.angle:+8
		
		glColor4f(Self.col[0], Self.col[1], Self.col[2], diff / 250.0)
		
		glPushMatrix()
		glTranslated(Self.posX, Self.posY, 0)
		glRotated(Self.angle, 0, 0, 1)
		Local u1:Float = 0.125 * Self.index
		Local u2:Float = 0.125 * (Self.index) + 0.125
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2f(u1, .5)
	'		glColor4f(Self.col[0], Self.col[1], Self.col[2], 1)
			glVertex2d(-Self.ssize, -Self.ssize)
			glTexCoord2f(u2, .5)
			glVertex2d(Self.ssize, -Self.ssize)
			glTexCoord2f(u1, 1)
			glVertex2d(-Self.ssize, Self.ssize)
			glTexCoord2f(u2, 1)
			glVertex2d(Self.ssize, Self.ssize)
		
		
		glEnd()
			glPopMatrix()
	End Method
	
	Function Create:TPartikel_Spawn(posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null)
				'Lifetime is immer erstmal ms + 2000!
		
		Local drehung:Float = 360.0 / 15.0
		Local drehung2:Float = drehung * Rand(0, 1)
				
		For Local i:Int = 0 Until 15
		Local part:TPartikel_Spawn = New TPartikel_Spawn
		
		part.lifeTime = ms + 250
		part.ssize = ssize * 2
		If col = Null Then col = [1.0, 1.0, 1.0]
		
		part.col = col
		
		part.index = 1
		part.posX = posX
		part.posY = posY

			part.angle = drehung2
			part.flug_angle = part.angle
		drehung2:+drehung
		
		part.speed = 2
		partikel.AddLast(part)
		Next
	'	Return part
	End Function
End Type

Type TPartikel_Fleisch_stuecke Extends TPartikel
	Field angle:Float = 0
	Field flug_angle:Float = 0
	Field speed:Float = 1.0
	Method Draw:Int()
		If Self.lifeTime < ms Then Return - 1
		Local diff:Int = Self.lifeTime - ms
		
		Self.posX:+(Cos(Self.flug_angle) * Self.speed)
		Self.posY:+(Sin(Self.flug_angle) * Self.speed)
		
		Self.angle:+8
		
		glColor4f(Self.col[0], Self.col[1], Self.col[2], diff / 500.0)
		
		glPushMatrix()
		glTranslated(Self.posX, Self.posY, 0)
		glRotated(Self.angle, 0, 0, 1)
		Local u1:Float = 0.125 * Self.index
		Local u2:Float = 0.125 * (Self.index) + 0.125
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2f(u1, .5)
	'		glColor4f(Self.col[0], Self.col[1], Self.col[2], 1)
			glVertex2d(-Self.ssize, -Self.ssize)
			glTexCoord2f(u2, .5)
			glVertex2d(Self.ssize, -Self.ssize)
			glTexCoord2f(u1, 1)
			glVertex2d(-Self.ssize, Self.ssize)
			glTexCoord2f(u2, 1)
			glVertex2d(Self.ssize, Self.ssize)
		
		
		glEnd()
			glPopMatrix()
	End Method
	
	Function Create:TPartikel_Fleisch_stuecke(posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null)
				'Lifetime is immer erstmal ms + 2000!
		
		For Local i:Int = 0 Until 5
		Local part:TPartikel_Fleisch_stuecke = New TPartikel_Fleisch_stuecke
		
		part.lifeTime = ms + 500
		part.ssize = ssize * 2
		If col = Null Then col = [1.0, 1.0, 1.0]
		
		part.col = col
		
		part.index = 0
		part.posX = posX
		part.posY = posY
		If flugrichtung = -1000 Then
			part.angle = Rand(0, 360)
			part.flug_angle = part.angle

		Else
			part.angle = Rand(flugrichtung - 45, flugrichtung + 45)
			part.flug_angle = part.angle

		EndIf
		part.speed = Rnd(.5, 4.5)
		partikel.AddLast(part)
		Next
	'	Return part
	End Function
End Type

Type TPartikel_Text Extends TPartikel
	Field str:String = ""
	
	Function Create:TPartikel_Spawn(posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null)
		
	End Function
	Function Create2:TPartikel_Text(str:String, posX:Float, posY:Float, sSize:Int = 8, flugrichtung:Float = -1000, col:Float[] = Null)
		Local part:TPartikel_Text = New TPartikel_text
		
		part.posX = posX
		part.posY = posY
		part.sSize = sSize
		part.str = str
		
		If col = Null Then col = [Float(Rnd(0.5, 1)), 0.0, 0.0, 1.0]
		part.lifeTime = ms + 500
		part.col = col
		
		partikel.AddLast(part)
		
	End Function
	
	Method Draw:Int()
	'	Print Self.str
		If Self.lifeTime < ms Then Return - 1
		
		Local diff:Int = Self.lifeTime - ms
		
		
		glColor4f(Self.col[0], Self.col[1], Self.col[2], diff / 500.0)
	'	glPushMatrix()
	'	glTranslated(Self.posX, Self.posY, 0)
		
		Local u1:Float = 0.125 * Self.index
		Local u2:Float = 0.125 * (Self.index) + 0.125
		
		
		GLDrawText(Self.str, Self.posX, Self.posY, 1, Self.ssize, Self.ssize * 1.5)
			
	'		glPopMatrix()
	End Method
End Type