﻿Type TSnakeAction
	Field snake:TSnake = Null 'ein zeiger auf die schlange, die dieses Action objekt besitzt! 
	
	Field endTime:Int = 0 'ein MS wert, wann die aktion zuende ist!
	Field duration:Int = 0 'ein MS wert, wielange die aktion insgesamt dauert!
	
	Method Update:Int() Abstract
	Method Move:Int() Abstract
	Method Flag:Int() Abstract
	Method Init:Int() Abstract
	
	Function CreateIdle(snake:TSnake, cd:Int)
		Local ACTION:TSnakeIdle = New TSnakeIdle
		ACTION.endTime = ms + cd
		ACTION.snake = snake
		snake.ACTION = ACTION
	'	Print "TSnakeIdle wurde erschaffen!"
	End Function
	Function Create:Int(snake:TSnake) Abstract
	
End Type
'Respawned!
Type TSnakeSpawn Extends TSnakeAction
	Field initAngle:Float = 0.0
	Field cnter:Int = 0
	Method Update:Int()
		If Self.cnter = 0 Then TPartikel_Spawn.Create(Self.snake.posX, Self.snake.posY, Rand(2, 5))
		Self.cnter = (Self.cnter + 1) Mod 30
	End Method
	
	Method Init:Int()
		
	End Method
	
	Method Move:Int()
		If Self.initAngle <> Self.snake.angle Or Self.endTime < ms Then
			TSnakeAction.CreateIdle(Self.snake, 0)
		End If
		
	End Method
	
	Method Flag:Int()
		Return - 1
	End Method
	
	Function Create:Int(snake:TSnake)
		Local ACTION:TSnakeSpawn = New TSnakeSpawn
		ACTION.endTime = ms + 10000 '10sek stehenbleiben!
		ACTION.initAngle = snake.angle
		ACTION.snake = snake
		snake.ACTION = ACTION
		snake.buff = TBuff_Godmode.Create(1,3000)
	'	Print "TSnakeSpawn wurde erschaffen!"
	End Function
End Type
'Schwanzhieb!
Type TSnakeTailSlash Extends TSnakeAction
	Field SlashDir:Int = Rand(0, 1)
	Field initAngle:Float = 0
	
	Field slashStart:Int = 0
	
	Method Update:Int()
	'	If Self.endTime < ms Then
	'		TSnakeAction.CreateIdle(Self.snake, 1500)
	'		Return Self.snake.ACTION.Update()
	'	EndIf
		
	End Method
	Method Init:Int()
		If Self.snake.lastSlashDir = 0 Then
		Self.SlashDir = Rand(0, 1)
		If Self.SlashDir = 0 Then Self.SlashDir = -1
		Else
			Self.SlashDir = Self.snake.lastSlashDir * -1
		EndIf
		
		Self.snake.lastSlashDir = Self.SlashDir
		Self.slashStart = Self.snake.parts.Count() / 2 - 1
		If Self.slashStart < 2 Then TSnakeIdle.Create(Self.snake)
'		Local maxSSize:Float = 70
'		Local tmpList:TList = Self.snake.parts.Copy()
'		tmpList.Reverse()
		
'		Local tmpSSize:Float = 0
'		Local counter:Int = tmpList.Count()
'		For Local part:TSnakePart = EachIn tmpList
'			counter:-1
'			tmpSSize:+part.ssize
'			If tmpSSize > maxSSize
'				Self.slashStart = counter
'				Exit
'			End If
'		Next
	'	If Self.slashStart < 2 Then Self.slashStart = 2
	End Method
	Method New()

	End Method

	Method Move:Int()
	
		If Self.endTime < ms + 60 Then
			TSnakeAction.CreateIdle(Self.snake, 1500)
			Return Self.snake.ACTION.Move()
		End If
	
		Self.snake.posX:+Cos(Self.snake.angle)
		Self.snake.posY:+Sin(Self.snake.angle)
		
		Self.TeileAnpassen() 'unter0r schied: Hier wird der schwanz anders bewegt, darum eine eigenmethode.
		
		Return 1
	
	End Method
	
	Method TeileAnpassen:Int()
		Local posX:Float = Self.snake.posX, posY:Float = Self.snake.posY, sSize:Float = 8.0
		Local angle:Float, dist:Float
		
	'	If Self.SlashDir = 0 Then Self.SlashDir = -1
		
		Local currentDirection:Int = Self.slashdir
		
	'	If Self.endTime - ms < Self.duration * 0.5 Then currentDirection:*- 2 'halbe zeit ist vergangen!
'		If Self.endTime - ms < Self.duration * 0.333 Then
'			currentDirection = (Self.SlashDir * -2) * (Self.endTime - ms + 1) / (Self.duration + 1) * 0.5
'			If currentDirection > 1.5 Then currentDirection = 1.5
'			If currentDirection < - 1.5 Then currentDirection = -1.5
'		ElseIf Self.endTime - ms < Self.duration * 0.6666 Then
'			currentDirection = Self.SlashDir * -2
'		End If
		
		
		Local angleAdd:Float = Self.initAngle
		
		Local lastAngle:Float = Self.snake.angle
'		Local startAngle:Float = Self.snake.angle
		Local Count:Int = Self.snake.parts.Count()
		Local cnt:Int = 0

	'	Local firstPart:TSnakePart = TSnakePart(Self.snake.parts.ValueAtIndex(Self.slashStart))
		
		Local gradPerTile:Float = ((((25.0)) / (Float(Count) - Float(Self.slashStart))))'/Float(count-self.slashstart)
		'gradPerTile enthält nun den wert, den es maximal haben soll! dh ings. ne drehung von 90° in der snake!
		'nun muss ich per Time ausrechnen, wieviel davon erreicht wurde-  hierzu brauche ich eine prozentuale rechnung :)
		'gegeben ist grundwert 
		gradPerTile:*((1 - (Self.endTime - ms) / Float(Self.duration)) * currentDirection) *.65
	'	Print "GradPerTile: "+gradPerTile
		Local gradPerTileInit:Float = gradPerTile
		'Print gradPerTile
	'	Print Self.initAngle
	'	If KeyDown(KEY_ENTER) Then DebugStop()
		For Local part:TSnakePart = EachIn Self.snake.parts
			cnt:+1
			If cnt > 2 And cnt > Self.slashStart Then
				'lastAngle = ((lastAngle + angleAdd) Mod 360)'- 180
				part.angle:+((gradPerTile) * 2.5)' * currentDirection') * (cnt - Self.slashStart)*0.5
				gradPerTile:*1.3
				If gradPerTile > gradPerTileInit * 3 Then gradPerTile = gradPerTileInit * 3
				part.posX = posX - Cos((part.angle)) * (dist + part.sSize)
				part.posY = posY - Sin((part.angle)) * (dist + part.sSize)
			'	part.angle = lastAngle
			'	Print "Last angle: " + lastAngle
		'		Print (.55 * currentDirection * (Self.slashStart + 1) / cnt)
'				angleAdd:+0.5 * currentDirection
'				If angleAdd > 5 Then angleAdd = 5
'				If angleAdd < - 5 Then angleAdd = -5
		'	Else
		'		startAngle = part.angle
			End If
			
			angle = ATan2(part.posY - posY, part.posX - posX) - 180' + angleAdd
		'		
		'	Print angleAdd
		'	Print currentDirection
			
			part.angle = angle
			
			dist = pyth(posX, posY, part.posX, part.posY)
			If dist > part.sSize + sSize + 1 Then
			'	Print "Dist: " + dist + " Size Total: " + (part.sSize + sSize + 1)
				part.posX:+Cos(part.angle) * (dist - (part.sSize + sSize))
	
				part.posY:+Sin(part.angle) * (dist - (part.sSize + sSize))
			
			EndIf

			posY = part.posY
			posX = part.posX
			sSize = part.sSize

			lastAngle = part.angle

		Next
		
		initAngle = angleAdd
	End Method
	
	Function Create:Int(snake:TSnake)
		snake.ACTION = New TSnakeTailSlash
		snake.ACTION.snake = snake
		snake.ACTION.endTime = ms + 300
		snake.ACTION.duration = 300
		
		snake.ACTION.Init()
	End Function
	Method Flag:Int()
		Return 3
	End Method
End Type
'Beißangriff!
Type TSnakeBiteAttack Extends TSnakeAction
	
	Method Update:Int()
		
	End Method
	
	Method Init:Int()
		
	End Method
	
	Method Move:Int()
		If Self.endTime < ms + 60 Then 'deine zeit ist abgelaufen, jimmy!
			TSnakeAction.CreateIdle(Self.snake, 2000)
			Return Self.snake.ACTION.Move()
		ElseIf Self.endTime > ms + 2000 Then 'hui, der will aber lange knabbern oO
			Self.endTime = (ms + 2000)
		
		EndIf
		
		'Hier das ATTACK movement!
		
		Self.snake.posX:+Cos(Self.snake.angle) * 2
		Self.snake.posY:+Sin(Self.snake.angle) * 2
		
		
		Local tmpList:TList = Self.snake.parts.Copy()
		Self.snake.TeileAnpassen()'tmpList, Self.snake.posX, Self.snake.posY, 8.0)
		
		Return 1
	End Method

	Method Flag:Int()
		Return 1
	End Method
	
	Function Create:Int(snake:TSnake)
		
	End Function
End Type
'Spuckangriff!
Type TSnakeChoking Extends TSnakeAction
	Field chokePos:Int = 0
	Field tmpPart:TSnakePart = Null
	
	Field nextChokeMove:Int = 0
	
	Method New()	
	End Method
	Method Init:Int()
	End Method
	Method Flag:Int()
		Return 2 'er kotzt grade- er isst nicht :D
	End Method
	Method Update:Int()
	End Method
	Method Move:Int()
	'	Print "choke move wird ausgeführt"
		If Self.endTime < ms + 60 Then 'deine zeit ist abgelaufen, jimmy!
			TSnakeAction.CreateIdle(Self.snake, 2000)
	'		Print "deine zeit ist abgelaufen jimmy"
			Return Self.snake.ACTION.Move()
		EndIf
		Self.endTime:+50
		
		'Choke-  normales movement!
	
		Self.snake.posX:+Cos(Self.snake.angle)
		Self.snake.posY:+Sin(Self.snake.angle)
		
		'Choke - hier wandern!
		If Self.nextChokeMove < ms Then
			If Self.chokePos = -1 Then

					TGeschoss.Create(Self.snake.posX, Self.snake.posY, Self.snake.angle, Self.tmpPart.ssize, Self.snake.color, 2.0, Self.snake.owner.index, Self.tmpPart.aussehen)
					TSnakePart(Self.snake.parts.First()).sSizeBoni:-Self.tmpPart.ssize
					
					TSnakeAction.CreateIdle(Self.snake, 1000)
			ElseIf Self.chokePos >= Self.snake.parts.Count() Then
				TSnakeAction.CreateIdle(Self.snake, 2000)
		'		Print "deine zeit ist abgelaufen jimmy"
				Return Self.snake.ACTION.Move()
			Else
				If Self.chokePos = Self.snake.parts.Count() - 1 Then
					'kotze ist im letzten part! nur was draufaddieren :>
				'	Print "Kotze is im anmarsch!"
				'	Print "ChokePos: " + chokePos + " Count: " + Self.snake.parts.Count()
					TSnakePart(Self.snake.parts.ValueAtIndex(Self.chokePos)).sSizeBoni:+Self.tmpPart.ssize
				Else
				'	Print "kotze fast da"
					TSnakePart(Self.snake.parts.ValueAtIndex(Self.chokePos + 1)).sSizeBoni:-Self.tmpPart.ssize
					TSnakePart(Self.snake.parts.ValueAtIndex(Self.chokePos)).sSizeBoni:+Self.tmpPart.ssize
				EndIf
			'	Print "chokepos: " + chokePos + " count: " + Self.snake.parts.Count()
				Self.chokePos:-1
			EndIf
			
			Self.nextChokeMove = 50 + ms
			Self.endTime:+50
		Else
		'	Print "Self.nextChokeMove < (Self.endTime - ms) == false!"
		EndIf
		Self.snake.TeileAnpassen()'tmpList, Self.snake.posX, Self.snake.posY, 8.0)
		
		Return 1
	End Method
	Function Create:Int(snake:TSnake)
		Local newChoking:TSnakeChoking = New TSnakeChoking
		newChoking.snake = snake

		newChoking.snake.ACTION = newChoking
		newChoking.tmpPart = TSnakePart(snake.parts.RemoveLast())
		newChoking.duration = (snake.parts.Count() + 1) * 75
		newChoking.endTime = ((snake.parts.Count() + 1) * 75) + ms
		newChoking.chokePos = snake.parts.Count() - 1 'kotze ist im letzten stück!
	End Function
End Type
'Idle - nur moven!
Type TSnakeIdle Extends TSnakeAction
	
	Method Update:Int()

	End Method
	
	Method Init:Int()
		
	End Method
	
	Method Move:Int()
		Self.snake.posX:+Cos(Self.snake.angle)
		Self.snake.posY:+Sin(Self.snake.angle)
		
	'	Local tmpList:TList = Self.snake.parts.Copy()
		Self.snake.TeileAnpassen()'tmpList, Self.snake.posX, Self.snake.posY, 8.0)
		
		Return 1
	End Method
	
	Method Flag:Int()
		Return 0
	End Method
	
	Function Create:Int(snake:TSnake)
		
	End Function
End Type

Type TSnakeMenue Extends TSnakeAction
	'Snake die immer an der MousePosition sitzt! Kleines gimminik ^^
	Method Update:Int()


	End Method
	
	Method Init:Int()
		
	End Method
	
	Method Move:Int()
		Local mx:Int = MouseX() - 128' - (SekTileCnt * TileSize)
		
		Local my:Int = MouseY()
'		If pyth(Self.snake.posX, Self.snake.posY, mx, my) > 0 Then

		'------------------------
		Local WorldWinkel:Float = ATan2(my - Self.snake.posy, mX - Self.snake.posx)
		
		WorldWinkel = (WorldWinkel + 360) Mod 360
		
		Local Zielwinkel:Float = WorldWinkel - Self.snake.angle
		If Zielwinkel < - 180 Then
			Zielwinkel:+360
		EndIf
		If Zielwinkel > 180 Then
			Zielwinkel:-360
		End If
		
	
			Self.snake.angle:+(Zielwinkel * 0.5)
		
		'-------------------------------------------------
		'	Self.snake.angle = ATan2(my - Self.snake.posy, mx - Self.snake.posx)
	'	EndIf
		Self.snake.posX = mx + Cos(Self.snake.angle - 180) * 2
		Self.snake.posY = my + Sin(Self.snake.angle - 180)*2
		Self.snake.TeileAnpassen()
	End Method
	
	Method Flag:Int()
		Return - 1
	End Method
	
	Function Create:Int(snake:TSnake)
		Local newChoking:TSnakeMenue = New TSnakeMenue
		newChoking.snake = snake

		newChoking.snake.ACTION = newChoking
	End Function
End Type