﻿SuperStrict
SeedRnd(MilliSecs())
Local config:ConfigFile = ConfigFile.LoadConfig("Config.ini")

Const TileSize:Int = 16
Const Snake_u:Double = 0.125
Const Snake_v:Double = 0.125
Const Snake_styles:Int = 8

Const partikel_u:Double = 32.0:Double / 256.0:Double
Const partikel_v:Double = 32.0:Double / 64.0:Double

Global ResX:Int = 1024
Global ResY:Int = 768
Global SekTileCnt:Int = ResY / TileSize
Global musikLevel:Float = Config.ReadEntry("Sound", "Musiklevel").ToInt() / 100.0
Global soundLevel:Float = Config.ReadEntry("Sound", "Soundlevel").ToInt() / 100.0
Global spielerZahl:Int = Config.ReadEntry("General", "Spielerzahl").ToInt()
Global kiZahl:Int = Config.ReadEntry("General", "KIzahl").ToInt()
Local fullscreen:Int = Config.ReadEntry("Graphic", "Fullscreen").ToInt()
If fullscreen < 0 Then fullscreen = 0
If fullscreen > 1 Then fullscreen = 1
Global lives_to_win:Int = Config.ReadEntry("General", "SiegPunktzahl").ToInt()
Global start_lives:Int = Config.ReadEntry("General", "StartPunktzahl").toInt()
Global SekPixelSize:Int = SekTilecnt * TileSize

Global playerColor:Float[,] = New Float[2, 3]
Local r:Int = Config.ReadEntry("Control_Player0", "ColorR").ToInt()
Local g:Int = Config.ReadEntry("Control_Player0", "ColorG").ToInt()
Local b:Int = Config.ReadEntry("Control_Player0", "ColorB").ToInt()
'Print r;Print g;Print b
If r + g + b < 127 Then
	While (r + g + b) < 127
		r:+1
		g:+1
		b:+1
		If r > 255 Then r = 255
		If g > 255 Then g = 255
		if b > 255 Then b = 255
	WEnd
EndIf
playerColor[0, 0] = r / 255.0
playerColor[0, 1] = g / 255.0
playerColor[0, 2] = b / 255.0

 r:Int = config.ReadEntry("Control_Player1", "ColorR").ToInt()
 g:Int = config.ReadEntry("Control_Player1", "ColorG").ToInt()
 b:Int = config.ReadEntry("Control_Player1", "ColorB").ToInt()
 If r + g + b < 127 Then
	While (r + g + b) < 127
		r:+1
		g:+1
		b:+1
		If r > 255 Then r = 255
		If g > 255 Then g = 255
		if b > 255 Then b = 255
	WEnd
EndIf
playerColor[1, 0] = r / 255.0
playerColor[1, 1] = g / 255.0
playerColor[1, 2] = b / 255.0
ConfigFile.Close(config)

'glewInit()

Include "Include\TKachel.bmx"
Include "Include\TSektor.bmx"
Include "Include\Hilfsfunktionen.bmx"
Include "Include\TGame.bmx"
Include "Include\TGeschoss.bmx"
Include "Include\TPartikel.bmx"
Include "Include\TSnake.bmx"
Include "Include\TSnakeAction.bmx"
Include "Include\TSpieler.bmx"
Include "Include\TWand.bmx"
Include "Include\Tbuff.bmx"
Include "Include\Ini Reader.bmx"
Include "Include\Key Assoziation.bmx"

StartOrthoGL(ResX, ResY, fullscreen * 32)

glewInit()


IncBin "gfx\land.png"
IncBin "gfx\Schlange.png"
IncBin "gfx\Partikel.png"
IncBin "gfx\GUI.png"
IncBin "Sounds\Folk_Fun-Q-Music-7755_hifi.ogg"
IncBin "Sounds\Drip-Public_d-168_hifi.ogg"
IncBin "Sounds\Ouch.ogg"
IncBin "gfx\GuiText.png"
IncBin "gfx\Logo.png"

Global tex:Int = GLTexFromPixmap(LoadPixmap("incbin::gfx\land.png"))
Global SchlangenTex:Int = GLTexFromPixmap(LoadPixmap("incbin::gfx\Schlange.png"))
Global blutTex:Int = GLTexFromPixmap(LoadPixmap("incbin::gfx\Partikel.png"))
Global GuiTex:Int = GLTexFromPixmap(LoadPixmap("incbin::gfx\GUI.png"))
Global GuiTextTex:Int = GLTexFromPixmap(LoadPixmap("incbin::gfx\GuiText.png"))
Global LogoTex:Int = GLTexFromPixmap(LoadPixmap("incbin::gfx\Logo.png"))
Global fontTex:Int
Global fontSeq:Int

glBindTexture(GL_TEXTURE_2D, tex)

Global menue:TMenue = TMenue.Create()
Global game:TGame = New TGame

Global gameState:Int = 0 'Menü!
glEnable(GL_TEXTURE_2D)
glEnable (GL_BLEND) ; glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
HideMouse()

Global MBLHit:Int = 0
Global MBLDown:Int = 0

Global musik:TSound = LoadSound("incbin::Sounds\Folk_Fun-Q-Music-7755_hifi.ogg", 1)
Global musikChannel:TChannel = Null

Global sounds:TSound[] = New TSound[2]
sounds[0] = LoadSound("incbin::Sounds\Drip-Public_d-168_hifi.ogg")
sounds[1] = LoadSound("incbin::Sounds\Ouch.ogg")

If musik Then musikChannel = musik.Play()
musikChannel.SetVolume(musikLevel)
'Print "hierhin komme ich - kurz vor mainloop"
TGame.prepareSektor()
Local cnter:Int = 0
While Not AppTerminate()
	cnter = (cnter + 1) Mod 10
	MBLHit = MouseHit(1)
	MBLDown = MouseDown(1)
	
	Select gameState
		Case 0
			if KeyHit(KEY_ESCAPE) Then exit
			If menue.Draw() = -1 Then
				Exit
			EndIf
		Case 2
			game.gameLoop()
		Case 1
			If drawHinweis() = 1 Then
				gameState = 2
			End If
		Case - 1
			Exit

	End Select
	
	If cnter = 0 Or cnter = 5 Then
	
	'	SFX(0)
		
	EndIf

'	FlushMouse()
Wend

If menue.config Then ConfigFile.Close(menue.config)

End

Function drawHinweis:Int()
		glPushMatrix()
		glTranslated((SekTileCnt * TileSize / 2), ResY / 2, 0)
	Cls
	GLDrawText("Anleitung: ", 0, -ResY / 2, 1)
	GLDrawText("Zum Steuern nutze bitte die Tasten, welche im Hautpmenue angezeigt wurden.", 0, -ResY / 2 + 40, 1)
	GLDrawText("Aendern kannst du das ganze in der datei ~qConfig.ini~q", 0, -ResY / 2 + 60, 1)
	GLDrawText("Das Spielziel ist es, deine Leben auf " + lives_to_win + " zu erhoehen.", 0, -ResY / 2 + 80, 1)
	GLDrawText("Um das zu erreichen, musst du andere Schlangen fressen - Leichen gehen ebenso gut!", 0, -ResY / 2 + 100, 1)
	GLDrawText("Soviel zu meinem BCC#53-Sammeln Beitrag! Viel spass :)", 0, -ResY / 2 + 150, 1)
	GLDrawText("Bitte eine Taste drücken...", 0, -ResY / 2 + 200, 1)
	

	
	Flip 1
	Delay(1000)
	FlushKeys()
	FlushMouse()
	WaitKey()
	
	glPopMatrix()
	Return 1
End Function