Type TBuff
	Field endTime:Int
	Field wert:Float
	
	Method Update:Int() Abstract
	Method Flag:Int() Abstract
	Function Create:TBuff(wert:Float, duration:Int) Abstract

End Type

Type TBuff_Godmode Extends TBuff
	Method Flag:Int()
		Return 10
	End Method
	Method Update:Int()
		If Self.endTime < ms Then
			Return - 1
		End If
		Return 1
	End Method
	Function Create:TBuff(wert:Float, duration:Int)
		Local tmpBuff:TBuff_Godmode = New TBuff_Godmode
		tmpBuff.endTime = duration + ms
		tmpBuff.wert = wert
		Return tmpBuff
	End Function
End Type

Type TBuff_SpeedUp Extends TBuff
	Method Flag:Int()
		Return 1
	End Method
	Method Update:Int()
		If Self.endTime < ms Then
			Return - 1
		End If
		Return 1
	End Method
	
	Function Create:TBuff(wert:Float, duration:Int)
		Local tmpBuff:TBuff_SpeedUp = New TBuff_SpeedUp
		tmpBuff.endTime = duration + ms
		tmpBuff.wert = wert
		Return tmpBuff
	End Function
End Type

Type Tbuff_nothing Extends TBuff
	Method Flag:Int()
		Return 0
	End Method
	Method Update:Int()
		Return 1
	End Method
	
	Function Create:TBuff(wert:Float, duration:Int)
		Local tmpbuff:TBuff_nothing = New TBuff_nothing
		tmpbuff.endTime = ms
		tmpbuff.wert = wert
		Return tmpbuff
	End Function
End Type