﻿
'Import BRL.PolledInput





'Gamespezifische Globals!
Global ms:Int = MilliSecs()

Global rottenSnakes:TList = CreateList()
Global Waende:TList = CreateList()
Global partikel:TList = CreateList()
Global Mitspieler:TList = CreateList()
Global Geschosse:TList = CreateList()

Type TGame
	Global land:TSektor = Null
	
	Field fps:Int = 0
	Field oldFps:Int = 0
	Field fpsTimer:Int = MilliSecs() + 1000
	
	Field playerCount:Int = 0
	Field KICount:Int = 0
	Function prepareSektor()
		TGame.land = TSektor.Create(0, 0)
	End Function
	Method New()
		Waende.AddLast(TWand.Create(0, 0, SekPixelSize, TileSize)) 'oben!
		Waende.AddLast(TWand.Create(0, SekPixelSize - TileSize, SekPixelSize, TileSize))
		Waende.AddLast(TWand.Create(0, 0, TileSize, SekPixelSize)) 'links
		Waende.AddLast(TWand.Create(SekPixelSize - TileSize, 0, TileSize, SekPixelSize))
	End Method
	Method Init()
		For Local i:Int = 0 Until Self.playerCount
			Local col:Float[] = New Float[3]
			col[0] = playerColor[i, 0]
			col[1] = playerColor[i, 1]
			col[2] = playerColor[i, 2]
			
			Mitspieler.AddLast(TSpieler.AddHuman(i, col))
		Next
		For Local i:Int = 0 Until Self.KICount
			Mitspieler.AddLast(TSpieler.AddAI(0, [Float(Rnd(0, 1)), Float(Rnd(0, 1)), Float(Rnd(0, 1))]))
		Next
	End Method
	
	Method GameLoop()
	'	While Not KeyHit(KEY_ESCAPE) And Not AppTerminate()
			Cls
			ms = MilliSecs()
			
			If Mitspieler.Count() = 1 Then
				menue.win(TSpieler(Mitspieler.First()).index)
			End If
	
				
		'	glTranslated(KeyDown(KEY_D) - KeyDown(KEY_A), KeyDown(KEY_W) - KeyDown(KEY_S), 0)
			glBindTexture(GL_TEXTURE_2D, tex)
		
				glEnableClientState(GL_VERTEX_ARRAY)
				glEnableClientState(GL_TEXTURE_COORD_ARRAY)
				glPushMatrix()
			'	glTranslated(-ResX / 2, -ResY / 2, 0)
				TGame.land.Draw()
				glPopMatrix()
				glDisableClientState((GL_TEXTURE_COORD_ARRAY))
				glDisableClientState(GL_VERTEX_ARRAY)
			
'				For Local wall:TWand = EachIn Waende
'				'	wall.Draw()
'				Next
		
			glColor4f(1, 1, 1, 1)
			glBindTexture(GL_TEXTURE_2D, blutTex)
			For Local pat:TPartikel = EachIn partikel
				If pat.Draw() = -1 Then partikel.Remove(pat)
			Next
			glBindTexture(GL_TEXTURE_2D, SchlangenTex)
		
			For Local player:TSpieler = EachIn Mitspieler
				If player.Update() = -1 Then
					Mitspieler.Remove(player)
				Else
					player.Draw()
				EndIf
			Next
			
			For Local rotten:TSnake = EachIn rottenSnakes
					If rotten.Draw() = 0 Then rottenSnakes.Remove(rotten)
			Next
			For Local bullet:TGeschoss = EachIn Geschosse
				bullet.Update()
				bullet.Draw()
			Next

			glColor4f(1, 1, 1, 1)
			
			fps:+1
			If fpsTimer <= MilliSecs() Then
			'	Print fps
				oldFps = fps
				fps = 0
				fpsTimer = MilliSecs() + 1000
			End If


			Local y:Int = 30
			For Local player:TSpieler = EachIn Mitspieler
				glColor3f(1 - player.color[0] * 0.2, 1 - player.color[1] * 0.2, 1 - player.color[2] * 0.2)
				GLDrawText("Spieler " + (player.index), -15, y, 0, 12, 16)
				GLDrawText("Leben: " + Int(player.lives), -15, y + 18, 1, 12, 16)
				y:+18 + 16
			Next
		'	While Not KeyDown(KEY_ENTER)
		'	
		'	Wend
		'	Delay 10
			Flip 1
	'	Wend
		If KeyHit(KEY_ESCAPE) Then
			gameState = -1
			menue.Config = ConfigFile.LoadConfig("Config.ini")
		EndIf
	End Method
	
	Function Create:TGame(plrCnt:Int = 1, kiCnt:Int = 1)
		'erstellt und initialisiert das Spiel!
		Mitspieler.Clear()
		rottenSnakes.Clear()
		partikel.Clear()
		Geschosse.Clear()
		Waende.Clear()
		TSpieler.indices = 0
		
		Local game:TGame = New TGame
		game.playerCount = plrCnt
		game.KICount = kiCnt
		
		
		If plrCnt < 1 Then game.playerCount = 1
		If game.playerCount + game.KICount < 2 Then game.KICount:+1
		
	'	Print "Neues Spiel wurde Createt. Playerzahl: " + game.playerCount + " - KIZahl: " + game.kicount
		game.Init()
		Return game
	End Function
End Type

Type TMenue
	Field MenueState:Int = 0 '0 -> Neues Spiel / Optionen / Ende
'	Field button_under_mouse:Int = -1 '-1 -> kein button!
	
'	Field GuiTex:Int = 0
	Field MouseSnake:TSnake '= New TSnakeLiving
	
	Field Config:ConfigFile = Null
	Field OptionsEntry:Int = 0
	
	Field TitleTex:Int = 0
	Field nextIncrease:Int = MilliSecs()
	

	
	Method New()
		Self.MouseSnake = TSnakeLiving.Create(3, MouseX(), MouseY(), TSpieler.AddHuman(0, [1.0, 1.0, 1.0, 0.65]), -135)
		Self.MouseSnake.isKilled = 1
		TSnakeMenue.Create(Self.MouseSnake)
		Self.MouseSnake.color = [1.0, 1.0, 1.0, 0.65]
		Self.TitleTex = LogoTex
	End Method
	
	Method Draw:Int()
		Cls
		Local retInt:Int = 0
		if Self.Config = Null Then Self.Config = ConfigFile.LoadConfig("Config.ini")
		
		
		Select Self.MenueState
			Case 0
				retInt = Self.DrawMenu1()
			Case 1
				Self.DrawOptionsMenue()
		End Select
		

		
		glBindTexture(GL_TEXTURE_2D, SchlangenTex)
		Self.MouseSnake.ACTION.Move()
		Self.MouseSnake.color = [1.0, 1.0, 1.0, 0.85]
		Self.MouseSnake.Draw()
		'GLDrawText("HIER!!", Self.MouseSnake.posx, Self.MouseSnake.posy)
		
		Flip 1
		
		Return retInt
		
	End Method
	
	Method Win(Player_number:Int)
		glColor4f(1, 1, 1, 1)
		While Not KeyHit(KEY_ENTER)

		
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then
				If Self.Config Then ConfigFile.Close(menue.Config)

				End
			End If
			Cls
			glPushMatrix()
	
			glTranslated((SekTileCnt * TileSize / 2), ResY / 2, 0)
			
			GLDrawText("Spieler nummer " + Player_number + " hat das Spiel gewonnen!", 0, 0, 1, 20, 28)
			GLDrawText("Herzlichen Glueckwunsch ;)", 0, 30, 1, 20, 28)
			GLDrawText("Dies war mein (bescheuerter) beitrag zum BCC.", 0, 60, 1, 10, 14)
			GLDrawText("Ich hoffe, du hattest wenigstens ein bisschen Spass. :-/", 0, 75, 1, 10, 14)
			GLDrawText("Eventuell wird das Spiel einmal ueberarbeitet.. nunja. Es hats noetig :D", 0, 95, 1, 10, 14)
			
			GLDrawText("Druecke nun ENTER, um zum Hauptmenü zurueckzukehren, ", 60, 150, 1, 14, 18)
			GLDrawText("oder aber Schließe das Fenster, bzw druecke ESCAPE, um das Spiel zu beenden.", 60, 170, 1, 14, 18)
	
	
			glPopMatrix()
			Flip 1

		Wend
		gameState = 0
		Self.MenueState = 0
	End Method
	Method loose(Player_number:Int)
		glColor4f(1, 1, 1, 1)
		While Not KeyHit(KEY_ENTER)

		
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then
				If Self.Config Then ConfigFile.Close(menue.Config)

				End
			End If
			Cls
			glPushMatrix()
	
			glTranslated((SekTileCnt * TileSize / 2), ResY / 2, 0)
			
			GLDrawText("Ai-Spieler nummer " + Player_number + " hat das Spiel gewonnen!", 0, 0, 1, 20, 28)
			GLDrawText("Pech gehabt ;) Versuchs nocheinmal!", 0, 30, 1, 20, 28)
			GLDrawText("Dies war mein (bescheuerter) beitrag zum BCC.", 0, 60, 1, 10, 14)
			GLDrawText("Ich hoffe, du hattest wenigstens ein bisschen Spass. :-/", 0, 75, 1, 10, 14)
			GLDrawText("Eventuell wird das Spiel einmal ueberarbeitet.. nunja. Es hats noetig :D", 0, 95, 1, 10, 14)
			
			GLDrawText("Druecke nun ENTER, um zum Hauptmenü zurueckzukehren, ", 60, 150, 1, 14, 18)
			GLDrawText("oder aber Schließe das Fenster, bzw druecke ESCAPE, um das Spiel zu beenden.", 60, 170, 1, 14, 18)
	
	
			glPopMatrix()
			Flip 1

		Wend
		gameState = 0
		Self.MenueState = 0
	End Method
	Method Update()
		
	End Method
	
	Function Create:TMenue()
		'Erstellt das simple hauptmenü.
	'	StartOrthoGL(800, 600)
		
		Local menue:TMenue = New TMenue
		menue.MenueState = 0
		menue.Config = ConfigFile.LoadConfig("config.ini")

		
		Return menue
	End Function
	Method DrawOptionsMenue()
		If KeyHit(KEY_ESCAPE) Then Self.MenueState = 0
		
		glBindTexture(GL_TEXTURE_2D, GuiTex)
		
		glColor4f(1, 1, 1, 1)
		
		Local mx:Int = MouseX() - ResX / 2, my:Int = MouseY() - ResY / 2
		
		Local posX:Float = -256
		Local posY:Float = -256
		Local sizeX:Float = 32.0
		Local sizeY:Float = 32.0
		
		Local u1:Float = 160.0 / 256.0
		Local v1:Float = 96.0 / 128.0
		Local u2:Float = 160.0 / 256.0 + 32.0 / 256.0
		Local v2:Float = 96.0 / 128.0 + 32.0 / 128.0
		
		glPushMatrix()
		glTranslated((SekTileCnt * TileSize / 2), ResY / 2, 0)
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posX = 256
				sizeX = -32
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posx = -256 + 32
				sizeX = 512 - 64
				
				u1 = u2
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				v1 = 110.0 / 128.0
				v2 = 0.9
				u1 = 160.0 / 256.0
				u2 = u1 + 32.0 / 256
				posX = -256
				sizeX = 32
				posy = posy + sizey
				sizeY = 512 - 64
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posx = 256
				sizeX = -32
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posx = -256 + 32
				sizeX = 512 - 64
				u1 = 170.0 / 256.0
				u2 = 180.0 / 256
				v1 = 105.0 / 128.0
				v2 = 110.0 / 128.0
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				
				'last not least
				 posX:Float = -256
				 posY:Float = 256
				 sizeX:Float = 32.0
				 sizeY:Float = -32.0
				
				 u1:Float = 160.0 / 256.0
				 v1:Float = 96.0 / 128.0
				 u2:Float = 160.0 / 256.0 + 32.0 / 256.0
				 v2:Float = 96.0 / 128.0 + 32.0 / 128.0
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posX = 256
				sizeX = -32
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posx = -256 + 32
				sizeX = 512 - 64
				
				u1 = u2 +.15
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				glColor3f(0.5, 0.5, 0.5)
				GLDrawText("Optionen", ResX / 2 - 20, ResY / 5)
				
				glColor4f(1, 1, 1, 1)
				'Next: Die knöpfe zum inhalt schalten!
				posx = -128 - 64
				posY = -256 - 28
				sizeX = 128
				sizeY = 32
				u1 = 128.0 / 256
				u2 = 1
				v1 = 0.0
				v2 = 32.0 / 128
				
				If mx > posx And mx < posx + sizeX And my > posy And my < posy + sizeY Then
					If MouseDown(1) Then
						Self.OptionsEntry = 0
					End If
				End If
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				posx = 64
				
				v1 = v2
				v2 = 64.0 / 128.0
				If mx > posx And mx < posx + sizeX And my > posy And my < posy + sizeY Then
					If MouseDown(1) Then
						Self.OptionsEntry = 1
					End If
				End If
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
				
				Select Self.OptionsEntry
					Case 0 'GRAFIK/SOUND AKTIV!
						posx = -128 - 64
						posY = -256 - 28
						sizeX = 128
						sizeY = 32
						u1 = 0.0
						u2 = 128.0 / 256
						v1 = 96.0 / 128.0
						v2 = 1.0
						
						glColor4f(1, 1, 1, 0.5)
						DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
						
					'	Self.drawGrafikAudio()
					Case 1 'STEUERUNG AKTIV!
						posx = 64
						posY = -256 - 28
						sizeX = 128
						sizeY = 32
						u1 = 0.0
						u2 = 128.0 / 256
						v1 = 96.0 / 128.0
						v2 = 1.0
						
						glColor4f(1, 1, 1, 0.5)
						DrawPattern(posx, posy, sizex, sizey, u1, v1, u2, v2)
					'	Self.drawSteuerung()
				End Select
		glPopMatrix()
		
		Function DrawPattern(posx:Float, posy:Float, sizeX:Float, sizeY:Float, u1:Float, v1:Float, u2:Float, v2:Float)
			glBegin(GL_TRIANGLE_STRIP)
				glTexCoord2d(u1, v1) ;glVertex2d(posx, posy)
				glTexCoord2d(u2, v1) ;glVertex2d(posx + sizeX, posy)
				glTexCoord2d(u1, v2) ;glVertex2d(posx, posy + sizeY)
				glTexCoord2d(u2, v2) ;glVertex2d(posX + sizeX, posY + sizeY)
			glEnd()
		End Function
	End Method

	Method DrawMenu1:Int()

		glPushMatrix()
		glTranslated((SekTileCnt * TileSize / 2), ResY / 2, 0)
		
		glBindTexture(GL_TEXTURE_2D, Self.TitleTex)
		glColor4f(1, 1, 1, 1)
		
		DrawPattern(-128, -300, 256, 128, 0, 0, 1, 1)
		
		glBindTexture(GL_TEXTURE_2D, GuiTex)
		
		glColor4f(1, 1, 1, 1)
		
		Local mx:Int = MouseX() - ResX / 2, my:Int = MouseY() - ResY / 2
		
	
		
		
		
		
		
			Local posX:Int = 0
			Local posY:Int = 0
			For Local i:Int = 0 To 2 Step 2 '3 buttons
				posX = -64
				posY = -32 - 16 + (i * 50) + (i * -10)
				
				glBegin(GL_TRIANGLE_STRIP)
					glTexCoord2d(0, .25 * i) ;glVertex2d(posX, posY)
					glTexCoord2d(.5, .25 * i) ;glVertex2d(posX + 128, posY)
					glTexCoord2d(0, .25 * i +.25) ;glVertex2d(posX, posY + 32)
					glTexCoord2d(.5, .25 * i +.25) ;glVertex2d(posX + 128, posY + 32)
				glEnd()
				If mx >= posX And mx <= posX + 128 And my >= posY And my <= posY + 32 Then
					glBegin(GL_TRIANGLE_STRIP)
						glTexCoord2d(0, .75) ;glVertex2d(posX, posY)
						glTexCoord2d(.5, .75) ;glVertex2d(posX + 128, posY)
						glTexCoord2d(0, 1) ;glVertex2d(posX, posY + 32)
						glTexCoord2d(.5, 1) ;glVertex2d(posX + 128, posY + 32)
					glEnd()
					If MBLDown Then
						Select i
							Case 0
								gameState = 1
								If Self.Config Then
									ConfigFile.Close(Self.Config)
									Self.Config = Null
								EndIf
								game = TGame.Create(spielerZahl, kiZahl)
							Case 1
'								Self.MenueState = 1
'								If Self.Config Then ConfigFile.Close(Self.Config)
'								Self.Config = ConfigFile.LoadConfig("Config.ini")
'								Self.OptionsEntry = 0 'GRAFIK/SOUND auswählen!
							Case 2
								If Self.Config Then
									ConfigFile.Close(Self.Config)
									Self.Config = null
								EndIf
						'		Print "WTF EXIT?!"
								Return - 1
						End Select
				
					End If
				EndIf
			Next

			glBindTexture(GL_TEXTURE_2D, GuiTextTex)

			Local x:Float = 0
			Local y:Float = 0
			Local sx:Float = 0
			Local sy:Float = 0
			Local u:Float = 0
			Local v:Float = 0
			Local us:Float = 0
			Local vs:Float = 0
			For Local i:Int = 0 Until 4 '4 button!
				'text!
				x = -500; y = -64 + (i * 32) ;sx = 128;sy = 32
				
				u = 0.0;v = (32.0 / 256.0) * i
				us = 128.0 / 256.0
				vs = 32.0 / 256.0
				
				DrawPattern(x, y, sx, sy, u, v, us + u, v + vs)
				
				'+..
				x = -500 + 128 + 50; y = -64 + 8 + (i * 32) ;sx = 16;sy = 16
				
				u = 128.0 / 256.0 + 16.0 / 256.0 ;v = 0
				us = 16.0 / 256.0
				vs = 16.0 / 256.0
				If mx > x And mx < x + sx And my > y And my < y + sy Then
					If MouseDown(1) And Self.nextIncrease < MilliSecs() Then
						glColor3f(1.0, 0.0, 0.0)
						Select i
							Case 0 'soundlevel
								Local wert:Int = Self.Config.ReadEntry("Sound", "Soundlevel").ToInt()
								If wert < 100 Then
									Self.Config.WriteData("Sound", "Soundlevel", wert + 1)
								EndIf
							Case 1 'musiklevel
								Local wert:Int = Self.Config.ReadEntry("Sound", "Musiklevel").ToInt()
								If wert < 100 Then
									Self.Config.WriteData("Sound", "Musiklevel", wert + 1)
								EndIf
							Case 2 'spielerzahl
								Local wert:Int = Self.Config.ReadEntry("General", "Spielerzahl").ToInt()
								If wert < 2 Then
									Self.Config.WriteData("General", "Spielerzahl", wert + 1)
								EndIf
							Case 3 'ki zahl
								Local wert:Int = Self.Config.ReadEntry("General", "KIzahl").ToInt()
								If wert < 100 Then
									Self.Config.WriteData("General", "KIzahl", wert + 1)
								EndIf
						End Select
						ResetGlobals(Self.Config)
						Self.nextIncrease = MilliSecs() + 100
		
					End If
				EndIf
				DrawPattern(x, y, sx, sy, u, v, us + u, v + vs)
				glColor3f(1.0, 1, 1)
				
				
				'-...
				x = -500 + 128; y = -64 + 8 + (i * 32) ;sx = 16;sy = 16
				
				u = 128.0 / 256.0 ;v = 0
				us = 16.0 / 256.0
				vs = 16.0 / 256.0
				If mx > x And mx < x + sx And my > y And my < y + sy Then
					If MouseDown(1) And Self.nextIncrease < MilliSecs() Then
						glColor3f(1.0, 0.0, 0.0)
						Select i
							Case 0 'soundlevel
								Local wert:Int = Self.Config.ReadEntry("Sound", "Soundlevel").ToInt()
								If wert > 0 Then
									Self.Config.WriteData("Sound", "Soundlevel", wert - 1)
								EndIf
							Case 1 'musiklevel
								Local wert:Int = Self.Config.ReadEntry("Sound", "Musiklevel").ToInt()
								If wert > 0 Then
									Self.Config.WriteData("Sound", "Musiklevel", wert - 1)
								EndIf
							Case 2 'spielerzahl
								Local wert:Int = Self.Config.ReadEntry("General", "Spielerzahl").ToInt()
								If wert > 1 Then
									Self.Config.WriteData("General", "Spielerzahl", wert - 1)
								EndIf
							Case 3 'ki zahl
								Local wert:Int = Self.Config.ReadEntry("General", "KIzahl").ToInt()
								If wert > 0 Then
									Self.Config.WriteData("General", "KIzahl", wert - 1)
								EndIf
						End Select
						ResetGlobals(Self.config)
						self.nextIncrease = MilliSecs()+100
		
					End If
				EndIf
				DrawPattern(x, y, sx, sy, u, v, us + u, v + vs)
				glColor3f(1.0, 1.0, 1.0)
			Next
		'	x = -500; y = -64 + (i * 32)
			If Self.Config Then
			Local val:String = Self.Config.ReadEntry("Sound", "Soundlevel")
			GLDrawText(val, -500 + 128 + 32, -64 + 8 + (0 * 32), 1, 8, 16)
			val:String = Self.Config.ReadEntry("Sound", "Musiklevel")
			GLDrawText(val, -500 + 128 + 32, -64 + 8 + (1 * 32), 1, 8, 16)
			val:String = Self.Config.ReadEntry("General", "Spielerzahl")
			GLDrawText(val, -500 + 128 + 32, -64 + 8 + (2 * 32), 1, 8, 16)
			val:String = Self.Config.ReadEntry("General", "KIzahl")
			GLDrawText(val, -500 + 128 + 32, -64 + 8 + (3 * 32), 1, 8, 16)
			
			glColor3f(.5, .5, .5)
			GLDrawText("STEUERUNG", 232, -263, 1, 17, 31)
			glColor3f(1.0, 1.0, 1.0)
			GLDrawText("STEUERUNG", 232, -262, 1, 16, 28)

			
			GLDrawText("Player1: ", 210, -230, 1, 10, 24)
			glColor3f(0.8, .8, .8)
			GLDrawText("Drehung Links:" + (Self.Config.ReadEntry("Control_Player0", "Left")), 250, -210)
			GLDrawText("Drehung Rechts:" + (Self.Config.ReadEntry("Control_Player0", "Right")), 250, -190)
			GLDrawText("Spucken::" + (Self.Config.ReadEntry("Control_Player0", "Choke").ToInt()), 250, -170)
			GLDrawText("Schwanzschlag:" + (Self.Config.ReadEntry("Control_Player0", "TailHit")), 250, -150)
			GLDrawText("Beißen:" + (Self.Config.ReadEntry("Control_Player0", "BiteAttack")), 250, -130)
			glColor3f(1.0, 1.0, 1.0)
			GLDrawText("Player2: ", 210, -100, 1, 10, 24)
			glColor3f(0.8, .8, .8)
			GLDrawText("Drehung Links:" + (Self.Config.ReadEntry("Control_Player1", "Left")), 250, -80)
			GLDrawText("Drehung Rechts:" + (Self.Config.ReadEntry("Control_Player1", "Right")), 250, -60)
			GLDrawText("Spucken::" + (Self.Config.ReadEntry("Control_Player1", "Choke")), 250, -40)
			GLDrawText("Schwanzschlag:" + (Self.Config.ReadEntry("Control_Player1", "TailHit")), 250, -20)
			GLDrawText("Beißen:" + (Self.Config.ReadEntry("Control_Player1", "BiteAttack")), 250, 0)
			EndIf
		glPopMatrix()
		If KeyHit(KEY_ESCAPE) Then
			gameState = 1
			If Self.Config Then
				ConfigFile.Close(Self.Config)
				Self.Config = null
			EndIf
			
			
			game = TGame.Create(spielerZahl, kiZahl)
		EndIf
		Function DrawPattern(posx:Float, posy:Float, sizeX:Float, sizeY:Float, u1:Float, v1:Float, u2:Float, v2:Float)
			glBegin(GL_TRIANGLE_STRIP)
				glTexCoord2d(u1, v1) ;glVertex2d(posx, posy)
				glTexCoord2d(u2, v1) ;glVertex2d(posx + sizeX, posy)
				glTexCoord2d(u1, v2) ;glVertex2d(posx, posy + sizeY)
				glTexCoord2d(u2, v2) ;glVertex2d(posX + sizeX, posY + sizeY)
			glEnd()
		End Function
	End Method
End Type
