﻿
Type TGeschoss
	Field posX:Float = 0.0
	Field posY:Float = 0.0
	
	Field owner:Int = 0 'zeiger auf den besitzer! 
	
	Field speed:Float = 1.0
	
	Field ssize:Float = 1.0
	
	Field color:Float[]
	
	Field angle:Float = 0.0
	
	Field aussehen:Int = 0
	
	Function Create(posX:Float, posY:Float, angle:Float, ssize:Float, color:Float[], speed:Float = 1.0, owner:Int = 0, aussehen:Int = 0)
		Local bullet:TGeschoss = New TGeschoss
		bullet.posX = posX
		bullet.posY = posY
		bullet.angle = angle
		bullet.speed = speed
		bullet.owner = owner
		bullet.ssize = ssize
		bullet.color = color
		bullet.aussehen = aussehen
		If color = Null Then
			bullet.color = [1.0, 1.0, 1.0]
		End If
		Geschosse.AddLast(bullet)
	End Function
	
	Method Update:Int()
		Self.posX:+Cos(Self.angle) * Self.speed
		Self.posY:+Sin(Self.angle) * Self.speed
		
		If Self.CheckCollision() = 1 Then
			Geschosse.Remove(Self)
			'partikel.AddLast(TPartikel_Blut.Create(Self.posX, Self.posY, Self.ssize))
			SFX(0)
		EndIf
	End Method
	
	Method Draw:Int()
		glColor3f(Self.color[0], Self.color[1], Self.color[2])
		glPushMatrix()
		
		glTranslated(Self.posX, Self.posY, 0) 'translaten!
		glRotated(Self.angle, 0, 0, 1)
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2d(0.0, Snake_v * Self.aussehen) ; glVertex2d(-Self.ssize, -Self.ssize)
			glTexCoord2d(Snake_u, Snake_v * Self.aussehen) ;glVertex2d(Self.ssize, -Self.ssize)
			glTexCoord2d(0.0, Snake_v * Self.aussehen + Snake_v) ;glVertex2d(-Self.ssize, Self.ssize)
			glTexCoord2d(Snake_u, Snake_v * Self.aussehen + Snake_v) ;glVertex2d(Self.ssize, Self.ssize)
		glEnd()
		glPopMatrix()
	End Method
	
	Method CheckCollision:Int()
		'Kugel gegen Wand?
		For Local wand:TWand = EachIn Waende
			If wand.CheckCollision(Self.posX, Self.posY, Self.ssize) = 1 Then
				Return 1 '1 -> projektil zerstören!
			EndIf
		Next 'Hierhin kams? Also nein!
		
		'Kugel gegen spieler? :)
		For Local player:TSpieler = EachIn Mitspieler
			If player.schlange
			'Feindliche schlange? Check for da headshot :D
		'	Print "Self.owner : " + Self.owner + " player.schlange.owner : " + player.schlange.owner
	
			'Wenn das nicht der eigene spieler ist.. (wenn owner==player.index dann kein Kopftreffer (wäre fugly -.-))
			If Self.owner <> player.index Then
				
				If Pixelweg(player.schlange.posX, player.schlange.posY, Self.posX, Self.posY) < (8 + Self.ssize) * 4 Then
					If pyth(player.schlange.posX, player.schlange.posY, Self.posX, Self.posY) <= (Self.ssize + 8 - 2) Then
						'kill him!
'						player.schlange.isKilled = 1
'						player.schlange.isRottenPart = 1
'						rottenSnakes.AddLast(player.schlange)
						If player.schlange.buff.Flag() = 10 Then
							Return 1
						Else
							TPartikel_Fleisch_stuecke.Create(player.schlange.posX, player.schlange.posY, 3, Self.angle)
							TPartikel_Fleisch_stuecke.Create(player.schlange.posX, player.schlange.posY, 3, Self.angle)
							TPartikel_Fleisch_stuecke.Create(player.schlange.posX, player.schlange.posY, 3, Self.angle)
							player.schlange.posX = -1000 'Kopf "entfernen" 
							player.schlange.posY = -1000 'Kopf "entfernen"
							player.KillSnake() 'Schlange tot :)
							
							Return 1 '1 -> projektil zerstören!
						End If

					EndIf
				End If
		
			End If
			
			Local alrdyCutted:Int = 0
			Local rottenSnake:TSnake = Null'New TSnake

			Local counter:Int = 0
			For Local part:TSnakePart = EachIn player.schlange.parts
				counter:+1
				If alrdyCutted = 1 Then
					If rottenSnake = Null Then rottenSnake = TSnakeRotten.Create2(0, -1000, -1000, TSpieler.AddHuman(0, player.schlange.color[..3]), -1000, player.schlange.aussehen)
					rottenSnake.parts.AddLast(part)
					player.schlange.parts.Remove(part)
				ElseIf Pixelweg(part.posX, part.posY, Self.posX, Self.posY) < (8 + part.ssize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(part.posX, part.posY, Self.posX, Self.posY) <= (part.sSize + 8 - 2) Then
						If player.schlange.buff.Flag() = 10 Then
							Return 1
						Else
							TPartikel_Fleisch_stuecke.Create(part.posX, part.posY, 3, Self.angle)
							TPartikel_Fleisch_stuecke.Create(part.posX, part.posY, 3, Self.angle)
							TPartikel_Fleisch_stuecke.Create(part.posX, part.posY, 3, Self.angle)
							
							part.ssize:-Self.ssize * 0.8
							If part.ssize < 0 Then
								If counter < 3 Then
	'								player.schlange.isKilled = 1
	'								player.schlange.isRottenPart = 1
	'								rottenSnakes.AddLast(player.schlange)
					
										player.schlange.parts.Remove(part)
										player.KillSnake()
										Return 1
							
								Else
	
										Return 1
					
										alrdyCutted = 1
										player.schlange.parts.Remove(part)
										Return 1
		
								End If
								
							Else
								Return 1
							EndIf
						EndIf
						'Return - 1 'ouch, immernoch fies.
'					ElseIf alrdyCutted = 1 Then
'						rottenSnake.parts.AddLast(part)
						
					End If
				EndIf
			Next
			If alrdyCutted = 1 Then
				If player.schlange Then
				If rottenSnake = Null Then rottenSnake = TSnakeRotten.Create2(0, -1000, -1000, TSpieler.AddHuman(0, player.schlange.color[..3]), -1000, player.schlange.aussehen)
				rottenSnakes.AddLast(rottenSnake)
				endif
				Return 1
			End If
			EndIf
		Next
		'Verrottende schlangen hier?
		For Local rottenSnake:TSnake = EachIn rottenSnakes
			If rottenSnake.isRottenPart = 0 And Pixelweg(rottenSnake.posX, rottenSnake.posY, Self.posX, Self.posY) < (8 + Self.ssize) * 4 Then
				'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
				If pyth(rottenSnake.posX, rottenSnake.posY, Self.posX, Self.posY) <= (8 + Self.ssize - 2) Then
						TPartikel_Fleisch_stuecke.Create(rottenSnake.posX, rottenSnake.posY, 3, Self.angle)
						TPartikel_Fleisch_stuecke.Create(rottenSnake.posX, rottenSnake.posY, 3, Self.angle)
						TPartikel_Fleisch_stuecke.Create(rottenSnake.posX, rottenSnake.posY, 3, Self.angle)
						
						rottenSnake.posX = -1000
						rottenSnake.posY = -1000
						
						Return 1 'ouch, immernoch fies.
				End If
			EndIf
			'oh hey ich lebe noch. Gleich mal die parts abchecken.
			For Local rottenPart:TSnakePart = EachIn rottenSnake.parts
				If Pixelweg(rottenPart.posX, rottenPart.posY, Self.posX, Self.posY) < (Self.ssize + rottenPart.ssize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(rottenPart.posX, rottenPart.posY, Self.posX, Self.posY) <= (Self.ssize + rottenPart.ssize - 2) Then
							TPartikel_Fleisch_stuecke.Create(rottenPart.posX, rottenPart.posY, 3, Self.angle)
							TPartikel_Fleisch_stuecke.Create(rottenPart.posX, rottenPart.posY, 3, Self.angle)
							TPartikel_Fleisch_stuecke.Create(rottenPart.posX, rottenPart.posY, 3, Self.angle)
							rottenSnake.parts.Remove(rottenPart)
							Return 1 'ouch, immernoch fies.
			
					End If
				EndIf
			Next
		Next
		
		For Local bullet:TGeschoss = EachIn Geschosse
			If bullet.posX = Self.posX And bullet.posY = Self.posY Then
			Else
				If Pixelweg(bullet.posX, bullet.posY, Self.posX, Self.posY) < (Self.ssize + bullet.ssize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(bullet.posX, bullet.posY, Self.posX, Self.posY) <= (Self.ssize + bullet.ssize - 2) Then
						Self.angle:+Rand(0, 359)
						bullet.angle:+Rand(0, 359)
						SFX(0)
						Return 0
					End If
				EndIf
			End If
		Next

		Return 0
	End Method
End Type