﻿Type TSnake
	Field posX:Float = 0
	Field posY:Float = 0
	
	Field angle:Float = 0
	
	Field laenge:Int = 4
	Field time:Int = 600
	
	Field color:Float[] = [Float(Rnd(0.3, 1.0)), Float(Rnd(0.3, 1.0)), Float(Rnd(0.3, 1.0))]
	Field aussehen:Int = Rand(0, 3)
	
	Field parts:TList = CreateList()
	Field lastPartUpdate:Int = MilliSecs()
	
	Field CurrentAction:Int = 0 'moveing :D
	Field CurrentACtionTime:Int = MilliSecs()
	
	Field isKilled:Int = 0
	Field isRottenPart:Int = 0
	
	
	Field lastSlashDir:Int = 0
	
	Field ACTION:TSnakeAction = New TSnakeIdle

	Field owner:TSpieler = Null
	
	Field buff:TBuff = TBuff_godMode.Create(1, 10000)
	
	Method Draw:Int() Abstract
	Method ResizeParts(Init:Int = 0)
		If Init = 1 Then
		Local cnt:Float = Self.parts.Count() 'enthält die anzahl der teile! und damit den grundwert :)
		Local counter:Int = cnt
		Local steigung:Float = ((1.0 - 0.4) / (cnt))
	'	Print "steigung: " + steigung
		Local sSize:Float = 1.0
		For Local parts:TSnakePart = EachIn Self.parts
		'	Print counter
			sSize = (counter * steigung) + 0.4
		'	Print "sSize: " + sSize
			counter:-1
		'	Print counter
			parts.sSize = 8.0 * sSize
		Next
		Else
		'	Print "------------~n ResizeParts wurde irgendwo aufgerufen!"
			DebugStop()
		EndIf
	End Method
	
	Method TeileAnpassen:Int()
		Local posX:Float = Self.posX, posY:Float = Self.posY, sSize:Float = 8.0
		Local angle:Float, dist:Float, totalDist:Float = 0.0
		For Local part:TSnakePart = EachIn Self.parts
			angle = ATan2(part.posY - posY, part.posX - posX) - 180
			
			part.angle = angle
			
			dist = pyth(posX, posY, part.posX, part.posY)
			If dist > part.sSize + sSize Then
			'	Print "Dist: " + dist + " Size Total: " + (part.sSize + sSize + 1)
				part.posX:+Cos(part.angle) * (dist - (part.sSize + sSize))
		
				part.posY:+Sin(part.angle) * (dist - (part.sSize + sSize))
		
			EndIf
			
			posY = part.posY
			posX = part.posX
			sSize = part.sSize
		Next
	'REWRITE ENDE
	rem
		If liste.Count() <= 0 Then Return 0
		Local part:TSnakePart = TSnakePart(liste.RemoveFirst())

		Local folgeKraft:Float = 1.0
		
		Local angle:Float = ATan2(part.posY - posY, part.posX - posX) - 180
	'	Print "angle1: " + part.angle + " angle2: " + angle + " Errechnet wird addiert: " + (-(part.angle - angle) * 0.5)

		part.angle = angle
		
		Local dist:Float = pyth(posx, posy, part.posX, part.posY)
		If dist > part.sSize + sSize + 1 Then
		'	Print "Dist: " + dist + " Size Total: " + (part.sSize + sSize + 1)
			part.versatzX = Cos(part.angle) * (dist - (part.sSize + sSize)) * folgeKraft
			part.posX:+part.versatzX
			part.versatzY = Sin(part.angle) * (dist - (part.sSize + sSize)) * folgeKraft
			part.posY:+part.versatzY
		EndIf
		Return Self.TeileAnpassen(liste, part.posX, part.posY, part.sSize)
	end rem
	End Method
	
	Method AddPart(part:TSnakePart, col:Float[])
		Local tmpPart:TSnakePart = TSnakePart(Self.parts.First())
		
		Local newPart:TSnakePart = TSnakePart.create2(part, Self.color)
		
		newPart.angle = tmpPart.angle
		newPart.posX = tmpPart.posX
		newPart.posY = tmpPart.posY
		newPart.posX:+Cos(Self.angle - 180)
		newPart.posY:+Sin(Self.angle - 180)

'		Local tmpR:Float = (col[0] - part.color[0]) * 0.33
'		Local tmpG:Float = (col[1] - part.color[1]) * 0.33
'		Local tmpB:Float = (col[2] - part.color[2]) * 0.33
'		part.color[0] = (part.color[0] + tmpR) / 2.0
'		part.color[2] = (part.color[1] + tmpG) / 2.0
'		part.color[1] = (part.color[2] + tmpB) / 2.0
'		
'		If part.color[0] < 0 Then part.color[0] = 0
'		If part.color[0] > 1.0 Then part.color[0] = 1
'		If part.color[1] < 0 Then part.color[1] = 0
'		If part.color[1] > 1.0 Then part.color[1] = 1
'		If part.color[2] < 0 Then part.color[2] = 0
'		If part.color[2] > 1.0 Then part.color[2] = 1
		
		Self.parts.AddFirst(newPart)
'		Self.ResizeParts()
		
		If Self.ACTION.Flag() = 1 Then
			'es ist davon auszugehen, das grade ein fressangriff läuft!
		'	Self.ACTION.endTime:+250
		'	Self.ACTION.duration:+250
		End If
	'	Self.CurrentACtionTime:+100
	'	If Self.CurrentACtionTime > ms + 2000 Then Self.CurrentACtionTime = ms + 2000
	End Method
	Method CheckCollision:Int(eating:Int = 0)
	
	'	If Self.owner.index = 1 Then Print "OWNER == 1 EATING == " + eating
		'Das naheliegenste: Wände!
		For Local wall:TWand = EachIn Waende
			If wall.CheckCollision(Self.posX, Self.posY, 8) = 1 Then
	'			Print "Lauf forest, laaauf! Ouch, donnet vor die wand :3"
				TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
				Self.owner.KillSnake()
				Return - 1 'ouch, das war fies.
			End If
		Next
	'	PLayer
		
		'Als nächstes: Die eigenen körperteile!
		If eating = -100 Then 'ohje, er kotzt? :3
			Local cnt:Int = 0
			Local ssizeAdd:Float = -4.0
			For Local part:TSnakePart = EachIn Self.parts
				cnt:+1
				If cnt = 1 Then
					ssizeAdd = -8.0
				Else
					ssizeAdd = 0
				EndIf
				If Pixelweg(part.posX, part.posY, Self.posX, Self.posY) < (8 + part.sSize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(part.posX, part.posY, Self.posX, Self.posY) <= (part.sSize + ssizeAdd + 8 - 2) Then
		'				Print "viele männer träumen davon, mitm mund an ihren eigenen schwanz zu kommen. WARUM hast du das nur probiert??"
						TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
						Self.owner.KillSnake()
						Return - 1 'ouch, immernoch fies.
					End If
				EndIf
			Next
		ElseIf eating = 0 then
			For Local part:TSnakePart = EachIn Self.parts
				If Pixelweg(part.posX, part.posY, Self.posX, Self.posY) < (8 + part.sSize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(part.posX, part.posY, Self.posX, Self.posY) <= (part.sSize + 8 - 2) Then
		'				Print "viele männer träumen davon, mitm mund an ihren eigenen schwanz zu kommen. WARUM hast du das nur probiert??"
						TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
						Self.owner.KillSnake()
						Return - 1 'ouch, immernoch fies.
					End If
				EndIf
			Next

		End If
		'Verrottende schlangen hier?
		For Local rottenSnake:TSnake = EachIn rottenSnakes
			If rottenSnake.isRottenPart = 0 And Pixelweg(rottenSnake.posX, rottenSnake.posY, Self.posX, Self.posY) < (16) * 4 Then
				'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
				If pyth(rottenSnake.posX, rottenSnake.posY, Self.posX, Self.posY) <= (16 - 2) Then
					If eating = 1 Then
						Self.AddPart(TSnakePart.Create(0, 0, 0, rottenSnake.aussehen, Self.color), Self.color)
						rottenSnake.posX = -1000
						rottenSnake.posY = -1000
						rottenSnake.isRottenPart = 1
						If rottenSnake.owner And (rottenSnake.owner.index <> Self.owner.index) Then
							Self.owner.lives:+2
						EndIf
					Else
			'			Print "Okay. du schändest leichen. aber war es DAS!! wert?"
						TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
						Self.owner.killSnake()
						Return - 1 'ouch, immernoch fies.
					End If
				End If
			EndIf
			'oh hey ich lebe noch. Gleich mal die parts abchecken.
			For Local rottenPart:TSnakePart = EachIn rottenSnake.parts
				If Pixelweg(rottenPart.posX, rottenPart.posY, Self.posX, Self.posY) < (8 + rottenPart.ssize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(rottenPart.posX, rottenPart.posY, Self.posX, Self.posY) <= (8 + rottenPart.ssize - 2) Then
						If eating = 1 Then
							rottenSnake.parts.Remove(rottenPart)
							Self.AddPart(rottenPart, Self.color)
						If rottenSnake.owner And (rottenSnake.owner.index <> Self.owner.index) Then
							Self.owner.lives:+0.5
						EndIf
						Else
					'		Print "Mh, leichenteile. Nun kuscheln deine mit ihnen :)"
							TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
							Self.owner.KillSnake()
							Return - 1 'ouch, immernoch fies.
						End If
					End If
				EndIf
			Next
		Next
		'Last not least: Kam uns so nen dummchen von KI in die quere?
		For Local player:TSpieler = EachIn Mitspieler 'einmal alle spieler, bitte :)
			'ah moment. Erstmal gucken, ob das mein besitzer ist :) Howto? :3 simplen posvergleich :(
			If player.schlange Then
			If player.schlange.posX = Self.posX And player.schlange.posY = Self.posY Then
				'Oh, hallo meine 2te Persönlichkeit :)
				
			Else
				Local newRotten:TSnake = Null
				'First of all: Snakeheads :D
				
		'		newRotten.parts.Clear() 'wir wollen keine teile in der rotten schlange!
				
				If Pixelweg(player.schlange.posX, player.schlange.posY, Self.posX, Self.posY) < (16 * 4) Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal.. achja, pythagoras ;)
					If pyth(player.schlange.posX, player.schlange.posY, Self.posX, Self.posY) <= (16 - 2) Then
						If eating = 1 And player.schlange.buff.Flag() <> 10 Then
							If player.schlange.ACTION.Flag() = 1 Then
						
									'hier ausklabustern! :D
									Local localAngleEnemy:Float = GetangleDiff(player.schlange.posX, player.schlange.posX, Self.posY, Self.posY, player.schlange.angle)
									Local localAngleSelf:Float = GetAngleDiff(Self.posy, Self.posy, player.schlange.posX, player.schlange.posY, Self.angle)
									
									If localAngleSelf > - 35 And localAngleSelf < 35 Then
										'Ich guck ziemlich direkt druff! :D
										Self.angle:+15 * (Sgn(-localAngleSelf))
										Self.posX:+Cos(Self.angle) * 2.0
										Self.posY:+Sin(Self.angle) * 2.0
									End If
									If localAngleEnemy > - 35 And localAngleEnemy < 35 Then
										'er guckt mich auch ziemlich direkt an :<
										player.schlange.angle:+15 * Sgn(-localAngleEnemy)
										player.schlange.posX:+Cos(player.schlange.angle) * 2.0
										player.schlange.posY:+Sin(player.schlange.angle) * 2.0
									End If
						
							Else
								If newRotten = Null Then newRotten = New TSnakeRotten
							'	Print "Playerkopf wurde gegessen."
								Self.AddPart(TSnakePart.Create(0, 0, 8, player.schlange.aussehen, Self.color), Self.color)
						'		player.schlange.isKilled = 1
						'		player.schlange.isRottenPart = 1
								TPartikel_Text.Create2("R.I.P", player.schlange.posX, player.schlange.posY, 12)
								player.schlange.posX = -1000
								player.schlange.posY = -1000
								rottenSnakes.AddLast(player.schlange)
								player.KillSnake()
								If player.index <> Self.owner.index Then
									Self.owner.lives:+4
								EndIf
								Self.TeileAnpassen()
							EndIf
						Else
						'	Print "Hallo Mr. Snake. Wunderschöne augen. Aber nun gehen sie bitte von mir runter."
							TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
							Self.owner.KillSnake()
							Return - 1 'aua :(
						End If
					End If
				End If
				'Der nächste schritt: Parts, parts, parts!

				Local alrdyEaten:Int = 0
				Local partCnt:Int = 0
				If player.schlange Then
				For Local part:TSnakePart = EachIn player.schlange.parts
					partCnt:+1
					If player.schlange Then
					If Pixelweg(part.posX, part.posY, Self.posX, Self.posY) < ((8 + part.sSize) * 4) Then
						'Der pixelweg ist schon gefährlich nah dran - Lieber mal.. achja, pythagoras ;)
						If pyth(part.posX, part.posY, Self.posX, Self.posY) <= ((8 + part.sSize) - 2) Then
							If eating = 1 And player.schlange.buff.Flag() <> 10 Then
								If partCnt < 3 Then player.KillSnake() 'der part ist sau nah am kopf! tötet ihn!
							
								If player.schlange Then
								player.schlange.parts.Remove(part)
								Self.AddPart(part, Self.color)
								If player.index <> Self.owner.index Then
									Self.owner.lives:+0.5
								EndIf
								alrdyEaten = 1
								EndIf
							Else
							'	Print "Du grabscht auch an jeden schwanz den du finden kannst, wie?"
								TPartikel_Text.Create2("R.I.P", Self.posX, Self.posY, 12)
								Self.owner.KillSnake()
								Return - 1 'aua :(
							End If
						ElseIf alrdyEaten = 1 Then 'er hat schon was von der schlange gefressen! 
							'scho gegessen->nachfolgendes in die rottensnake kopieren!
							If player.schlange Then
							player.schlange.parts.Remove(part)
							If newRotten = Null Then newRotten = New TSnakeRotten
							newRotten.parts.AddLast(part)
							EndIf
						End If
					ElseIf alrdyEaten = 1 Then 'er hat schon was von der schlange gefressen! 
						'scho gegessen->nachfolgendes in die rottensnake kopieren!
						If newRotten = Null Then newRotten = New TSnakeRotten
						If player.schlange Then
						player.schlange.parts.Remove(part)
						newRotten.parts.AddLast(part)
						EndIf
					End If
					endif
				Next
				EndIf
				If alrdyEaten = 1 Then 'NUR ne schlange adden, wenn es was zu adden gibt!
					'fertig: aus rotten parts eine neue schlange und aus newParts die neuen teile fertigen :)
					If newRotten = Null Then newRotten = New TSnakeRotten
					newRotten.posX = -1000
					newRotten.posY = -1000
					newRotten.isRottenPart = 1
					newRotten.isKilled = 1
					newRotten.color = player.schlange.color[..4]
				'	newRotten.time = ms
				'	player.schlange.ResizeParts()
					rottenSnakes.AddLast(newRotten)
					
				'	player.KillSnake()
				EndIf
			EndIf
			EndIf
		Next
	End Method
	Method MOVE_Left()
		Self.angle:-3.5
	End Method
	Method MOVE_Right()
		Self.angle:+3.5
	End Method
	Method Attack()
		If Self.ACTION.endTime < ms Or Self.ACTION.Flag() = -1 Then
			Self.ACTION = New TSnakeBiteAttack
			Self.ACTION.snake = Self
			Self.ACTION.endTime = ms + 1200
			Self.ACTION.duration = 1200
		EndIf
	End Method
	Method NewActionPossible:Int()
		If Self.ACTION.endTime < ms Or Self.ACTION.Flag() = -1 Then
			Return 1
		EndIf
		Return 0
	End Method

	Method Choke()
		If (Self.ACTION.endTime < ms Or Self.ACTION.Flag() = -1) And Self.parts.Count() > 2 Then
			TSnakeChoking.Create(Self)
		End If
	End Method
	
	Method SchwanzHieb()
		If Self.ACTION.endTime < ms Or Self.ACTION.Flag() = -1 Then
			TSnakeTailSlash.Create(Self)

		EndIf
	End Method
	
	Method Move:Int()
		If Self.isKilled = 1 Then Return - 1
		
		Self.ACTION.Update()
		Self.ACTION.Move()
	End Method
	

End Type

Type TSnakeLiving Extends TSnake

	Function Create:TSnake(laenge:Int, posx:Float, posY:Float, owner:TSpieler, initAngle:Float = -1000, aussehen:Int = -1, color:Float[] = Null)
		If color = Null Then
			If owner And owner.color And Len(owner.color) > 3 Then
				color = owner.color
			Else
				color = [1.0, 1.0, 1.0, 1.0]
			End If
		'	color = [1.0, 1.0, 1.0, 1.0]
		EndIf
		If aussehen = -1 Then aussehen = Rand(0, Snake_styles - 1)
		If initAngle = -1000 Then initAngle = Rnd(0, 359.9999)
		If owner = Null Then RuntimeError("Eine schlange sollte ohne besitzer erstellt werden. Scheisst der papst in den Wald?")
		
		Local snake:TSnakeLiving = New TSnakeLiving
		snake.owner = owner
		snake.laenge = laenge
		snake.angle = initAngle
		snake.parts = CreateList()
		snake.aussehen = aussehen
		snake.posx = posx
		snake.posY = posY
		snake.color = color
		TSnakeSpawn.Create(snake)
		
		For Local i:Int = 1 To laenge
			Local newPart:TSnakePart = TSnakePart.Create(posx + ((16) * Cos(snake.angle - 180)), posY + ((16) * Sin(snake.angle - 180)), 8, aussehen, snake.color)
				
	'			newPart.posx = posx + ((16) * Cos(snake.angle - 180))
	'			newPart.posY = posY + ((16) * Sin(snake.angle - 180))
			'	newPart.sSize = 8
		'	newPart.versatzX = 0
		'	newPart.versatzY = 0
			snake.parts.AddLast(newPart)
		Next
		snake.ResizeParts(1)
		
		Return snake
	End Function
	Method New()
		'TSnakeSpawn.Create(Self)
	'	Self.ACTION.snake = Self
		
	'	Self.posX = Rand(32, TileSize * SekTileCnt - 32)
	'	Self.posY = Rand(32, TileSize * SekTileCnt - 32)

	'	Self.angle = Rand(0, 359)
	'	Self.laenge = 6
		
	'	For Local i:Int = 1 To laenge
	'		Local newPart:TSnakePart = TSnakePart.Create(Self.posX + ((16 * i) * Cos(Self.angle - 180)), Self.posY + ((16 * i) * Sin(Self.angle - 180)), 8, Self.aussehen)
	'			newPart.posX = Self.posX + ((16 * i) * Cos(Self.angle - 180))
	'			newPart.posY = Self.posY + ((16 * i) * Sin(Self.angle - 180))

		'	newPart.versatzX = 0
		'	newPart.versatzY = 0
	'		Self.parts.AddLast(newPart)
	'	Next
	'	Self.ResizeParts()
'		DebugStop()
	End Method


	

	Method Draw:Int()
		'If col = Null Then col = [1.0, 1.0, 1.0, 1.0]
		'col = Self.color +[1.0]
		
		Local col:Float[] = New Float[4]
		If Self.color And Len(Self.color) >= 4 Then
			col = Self.color
		ElseIf Self.color And Len(Self.color) = 3 Then
			col = Self.color +[1.0]
		Else
		
		EndIf
		
		Local newAlpha:Float = col[3]
		If Self.isKilled <> 1 Then
		
		If Self.buff.Flag() = 10 Then
			'er ist im godmode! Blinkeffekt einfügen! :<
			newAlpha = 1.0 * (((ms & 500) / 500.0))
	
		End If
		EndIf
'		If isRotten = 1 Then
'			If Self.time <= 0 Then Return 0
'			newAlpha = ((Self.time / 600.0) / 2.0) + 0.5
'			glColor4f(col[0], col[1], col[2], newAlpha)
'			Self.time:-1
'		Else
		'	If Len(col) = 4 Then
				glColor4f(col[0], col[1], col[2], newAlpha)
		'	Else
		'		glColor3f(col[0], col[1], col[2])
		'	EndIf
'		EndIf
		glPushMatrix()
		
		glTranslated(Self.posX, Self.posY, 0) 'translaten!
		glRotated(Self.angle, 0, 0, 1)
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2d(Snake_u, Snake_v * Self.aussehen) ; glVertex2d(-8, -8)
			glTexCoord2d(Snake_u * 2, Snake_v * Self.aussehen) ;glVertex2d(8, -8)
			glTexCoord2d(Snake_u, Snake_v * Self.aussehen + Snake_v) ;glVertex2d(-8, 8)
			glTexCoord2d(Snake_u * 2, Snake_v * Self.aussehen + Snake_v) ;glVertex2d(8, 8)
		glEnd()
	

		

	'	GLDrawText(Self.posX + " / " + Self.posY, Self.posX + Self.versatzX, Self.posY + Self.versatzY)
	'	GLDrawText(Self.parts.Count(), 10, 10)
		glPopMatrix()
		
		Local counter:Int = 0'enthält die anzahl der teile! und damit den grundwert :)
		Local maxCount:Int = Self.parts.Count()
		For Local parts:TSnakePart = EachIn Self.parts
		'	sSize = counter / Self.parts.Count()
			counter:+1
			glPushMatrix()
		'	If col = Null Then col = [1.0, 1.0, 1.0, 1.0]
		'	parts.color = parts.color[..4]
		'	parts.color[3] = col[3]
			
			glTranslated(parts.posX, parts.posY, 0)
			glRotated((parts.angle) - 180, 0, 0, 1)
			
		'	glColor4f(parts.color[0], parts.color[1], parts.color[2], newAlpha)
			
			If counter = maxCount Then
				glBegin(GL_TRIANGLE_STRIP)
					glTexCoord2d(Snake_u * 3, Snake_v * parts.aussehen) ; glVertex2d(-parts.sSize - parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(Snake_u * 2, Snake_v * parts.aussehen) ;glVertex2d(parts.sSize + parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(Snake_u * 3, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(-parts.sSize - parts.ssizeboni, parts.sSize + parts.ssizeboni)
					glTexCoord2d(Snake_u * 2, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(parts.sSize + parts.ssizeboni, parts.sSize + parts.ssizeboni)
				glEnd()
			Else
				glBegin(GL_TRIANGLE_STRIP)
					glTexCoord2d(0.0, Snake_v * parts.aussehen) ; glVertex2d(-parts.sSize - parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(Snake_u, Snake_v * parts.aussehen) ;glVertex2d(parts.sSize + parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(0.0, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(-parts.sSize - parts.ssizeboni, parts.sSize + parts.ssizeboni)
					glTexCoord2d(Snake_u, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(parts.sSize + parts.ssizeboni, parts.sSize + parts.ssizeboni)
				glEnd()
			EndIf

			glPopMatrix()
		Next
		Return 1
	End Method
	


End Type

Type TSnakeRotten Extends TSnake

	Function Create:TSnake(oldSnake:Tsnake)
		Local newRotten:TSnakeRotten = New TSnakeRotten
		
		newRotten.posX = oldSnake.posX
		newRotten.posY = oldSnake.posY
		newRotten.angle = oldSnake.angle
		newRotten.aussehen = oldSnake.aussehen
		newRotten.color = oldSnake.color[..4]
		newRotten.laenge = oldSnake.laenge
		newRotten.owner = oldSnake.owner
		newRotten.time = oldSnake.time
		newRotten.parts = oldSnake.parts
	
		Return newRotten
	End Function
	Function Create2:TSnake(laenge:Int, posx:Float, posY:Float, owner:TSpieler, initAngle:Float = -1000, aussehen:Int = -1, color:Float[] = Null)
		If color = Null Then
			If owner And owner.color And Len(owner.color) > 3 Then
				color = owner.color
			Else
				color = [1.0, 1.0, 1.0, 1.0]
			End If
		'	color = [1.0, 1.0, 1.0, 1.0]
		EndIf
		If aussehen = -1 Then aussehen = Rand(0, Snake_styles - 1)
		If initAngle = -1000 Then initAngle = Rnd(0, 359.9999)
		If owner = Null Then RuntimeError("Eine schlange sollte ohne besitzer erstellt werden. Scheisst der papst in den Wald?")
		
		Local snake:TSnakeRotten = New TSnakeRotten
		snake.owner = owner
		snake.laenge = laenge
		snake.angle = initAngle
		snake.parts = CreateList()
		snake.aussehen = aussehen
		snake.posx = posx
		snake.posY = posY
		snake.color = color
		TSnakeSpawn.Create(snake)
		
		For Local i:Int = 1 To laenge
			Local newPart:TSnakePart = TSnakePart.Create(posx + ((16) * Cos(snake.angle - 180)), posY + ((16) * Sin(snake.angle - 180)), 8, aussehen, snake.color)
				
	'			newPart.posx = posx + ((16) * Cos(snake.angle - 180))
	'			newPart.posY = posY + ((16) * Sin(snake.angle - 180))
			'	newPart.sSize = 8
		'	newPart.versatzX = 0
		'	newPart.versatzY = 0
			snake.parts.AddLast(newPart)
		Next
	'	snake.ResizeParts(1)
		
		Return snake
	End Function
	Method Draw:Int()
		'If col = Null Then col = [1.0, 1.0, 1.0, 1.0]
		'col = Self.color +[1.0]
		Local col:Float[] = New Float[4]
		If Self.color And Len(Self.color) >= 4 Then
			col = Self.color
		ElseIf Self.color And Len(Self.color) = 3 Then
			col = Self.color +[1.0]
			Self.color:+[1.0]
		Else
			
		EndIf
		
		Local newAlpha:Float = col[3]

		If Self.time <= 0 Then Return 0
		newAlpha = ((Self.time / 600.0) / 2.0) + 0.5
		glColor4f(col[0], col[1], col[2], newAlpha)
		Self.time:-1

		'color aufhellen! 
		Self.color[0] = (Self.color[0] + 0.001)
		Self.color[1] = (Self.color[1] + 0.001)
		Self.color[2] = (Self.color[2] + 0.001)
		Self.color[3] = newAlpha
		If Self.color[0] > 1 Then Self.color[0] = 1
		If Self.color[1] > 1 Then Self.color[1] = 1
		If Self.color[2] > 1 Then Self.color[2] = 1
		
		glPushMatrix()
		
		glTranslated(Self.posX, Self.posY, 0) 'translaten!
		glRotated(Self.angle, 0, 0, 1)
		
		glBegin(GL_TRIANGLE_STRIP)
			glTexCoord2d(Snake_u, Snake_v * Self.aussehen) ; glVertex2d(-8, -8)
			glTexCoord2d(Snake_u * 2, Snake_v * Self.aussehen) ;glVertex2d(8, -8)
			glTexCoord2d(Snake_u, Snake_v * Self.aussehen + Snake_v) ;glVertex2d(-8, 8)
			glTexCoord2d(Snake_u * 2, Snake_v * Self.aussehen + Snake_v) ;glVertex2d(8, 8)
		glEnd()
	

		

	'	GLDrawText(Self.posX + " / " + Self.posY, Self.posX + Self.versatzX, Self.posY + Self.versatzY)
	'	GLDrawText(Self.parts.Count(), 10, 10)
		glPopMatrix()
		
		Local counter:Int = 0'enthält die anzahl der teile! und damit den grundwert :)
		Local maxCount:Int = Self.parts.Count()
		For Local parts:TSnakePart = EachIn Self.parts
		'	sSize = counter / Self.parts.Count()
			counter:+1
			glPushMatrix()
		'	If col = Null Then col = [1.0, 1.0, 1.0, 1.0]
		
			
			glTranslated(parts.posX, parts.posY, 0)
			glRotated((parts.angle) - 180, 0, 0, 1)
			
		'	glColor4f(col[0], col[1], col[2], newAlpha)
			
			If counter = maxCount Then
				glBegin(GL_TRIANGLE_STRIP)
					glTexCoord2d(Snake_u * 3, Snake_v * parts.aussehen) ; glVertex2d(-parts.sSize - parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(Snake_u * 2, Snake_v * parts.aussehen) ;glVertex2d(parts.sSize + parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(Snake_u * 3, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(-parts.sSize - parts.ssizeboni, parts.sSize + parts.ssizeboni)
					glTexCoord2d(Snake_u * 2, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(parts.sSize + parts.ssizeboni, parts.sSize + parts.ssizeboni)
				glEnd()
			Else
				glBegin(GL_TRIANGLE_STRIP)
					glTexCoord2d(0.0, Snake_v * parts.aussehen) ; glVertex2d(-parts.sSize - parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(Snake_u, Snake_v * parts.aussehen) ;glVertex2d(parts.sSize + parts.ssizeboni, -parts.sSize - parts.ssizeboni)
					glTexCoord2d(0.0, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(-parts.sSize - parts.ssizeboni, parts.sSize + parts.ssizeboni)
					glTexCoord2d(Snake_u, Snake_v * parts.aussehen + Snake_v) ;glVertex2d(parts.sSize + parts.ssizeboni, parts.sSize + parts.ssizeboni)
				glEnd()
			EndIf

			glPopMatrix()
		Next
		Return 1
	End Method
End Type

Type TSnakePart
	Field posX:Float = 0
	Field posY:Float = 0
'	Field versatzX:Float = -1000
'	Field versatzY:Float = -1000
'	Field dir:Int = 0 'gibt an, in welche richtung der Part unterwegs ist!
	
	Field aussehen:Int = 0
	
	Field angle:Float = 0.0

	Field sSize:Float = 1.0
	Field sSizeBoni:Float = 0.0
	
	Field color:Float[] = [1.0, 1.0, 1.0, 1.0]
	
'	Field eaten:Int = 0
	
	Function Create:TSnakePart(posX:Float, posY:Float, sSize:Float, aussehen:Int, color:Float[])
		Local part:TSnakePart = New TSnakePart
		part.color = color
		part.posX = posX
		part.posY = posY
		part.sSize = sSize
		part.aussehen = aussehen
		
		Return part
	End Function
	
	Function Create2:TSnakePart(oldPart:TSnakePart, newCol:Float[])
		Local part:TSnakePart = New TSnakePart
		
		part.color = newCol[..4]
		part.posX = oldPart.posX
		part.posY = oldPart.posY
		part.sSize = oldPart.sSize
		part.aussehen = oldPart.aussehen
		
		Return part
	End Function
End Type