﻿Type TSpieler
	Field color:Float[] = [Float(Rnd(0.3, 1.0)), Float(Rnd(0.3, 1.0)), Float(Rnd(0.3, 1.0))]
	Field aussehen:Int = Rand(0, snake_styles - 1)
	
	Field schlange:TSnake = Null
	Field index:Int = 0
	Global indices:Int = 0
	Field lives:Float = 10
	
	Field respawnTime:Int = 0
	Field spawn_partikel_speed:Float = 0
	Field spawn_angle:Float = 0
	Field respawnMarkerX:Float = 0
	Field respawnMarkerY:Float = 0
	Field deathMarkerX:Float = 0
	Field deathMarkerY:Float = 0
	Field respawn_partikel_cnter:Int = 0
	Method KillSnake()
		Self.lives:-1
		SFX(1).SetRate(Rnd(0.7, 1.3))
		If Self.lives = 0 Then
			Mitspieler.Remove(Self)
		End If
		For Local part:TSnakePart = EachIn Self.schlange.parts
			part.sSizeBoni = 0
		Next
		Self.schlange.buff = Tbuff_nothing.Create(0, 0)
		Self.schlange.isKilled = 1
		rottenSnakes.AddLast(TSnakeRotten.Create(Self.schlange))
		
		Self.respawnTime = ms + 3000
		
		Self.deathMarkerX = Self.schlange.posX
		Self.deathMarkerY = Self.schlange.posY
		Self.respawnMarkerX = Rnd(64, SekPixelSize - 64)
		Self.respawnMarkerY = Rnd(64, SekPixelSize - 64)
		Self.spawn_angle = GetAngleDiff(Self.deathMarkerX, Self.deathMarkerY, Self.respawnMarkerX, Self.respawnMarkerY, Self.schlange.angle) + Self.schlange.angle
	'	Self.spawn_angle = ATan2(Self.deathMarkerY - Self.respawnMarkerY, Self.deathMarkerX - Self.respawnMarkerX)
		
		Self.spawn_partikel_speed = pyth(Self.deathMarkerX, Self.deathMarkerY, Self.respawnMarkerX, Self.respawnMarkerY) / 3000.0
		Self.respawn_partikel_cnter = 0
		
		Self.schlange = Null
	'	Self.schlange.owner = Self
	'	Self.schlange.color = Self.color
	End Method
	
	Method RespawnSnake:Int()
		If Self.respawnTime < ms And Self.schlange = Null Then
			Self.schlange = TSnakeLiving.Create(5, Self.respawnMarkerX, Self.respawnMarkery, Self, -1000, Self.aussehen, Self.color)
		Else
			If Self.respawn_partikel_cnter = 0 Then
				TPartikel_Spawn_location.Create(Self.respawnMarkerX + (Cos(Self.spawn_angle) * Self.spawn_partikel_speed * Float(ms - Self.respawnTime)), Self.respawnMarkerY + (Sin(Self.spawn_angle) * Self.spawn_partikel_speed * (ms - Self.respawnTime)), 4, -1000, Self.color[..4])
		'	TPartikel_Spawn_location.Create(Self.respawnMarkerX, Self.respawnMarkerY, 4, -1000, Self.color[..4])
			End If
			Self.respawn_partikel_cnter = (Self.respawn_partikel_cnter + 1) Mod 3
		EndIf
	End Method
	Function AddHuman:TMenschlicherSpieler(keyLayout:Int = 0, color:Float[] = Null)
		Local hum:TMenschlicherSpieler = New TMenschlicherSpieler
		hum.index = TSpieler.indices + 1
		TSpieler.indices:+1
		If color <> Null Then
			hum.color = color
		End If
		
		hum.schlange = TSnakeLiving.Create(5, Rand(64, SekPixelSize - 64), Rand(64, SekPixelSize - 64), hum, -1000, hum.aussehen, color)
	'	hum.schlange.owner = hum.index
		'hum.schlange.color = color
		
		Local conf:ConfigFile = ConfigFile.LoadConfig("Config.ini")
		Local key_string:String = conf.ReadEntry("Control_Player" + keyLayout, "Left")
		hum.KLeft = GetKeyconstFromString(key_string)
		hum.KRight = GetKeyconstFromString(conf.ReadEntry("Control_Player" + keyLayout, "Right"))
		hum.KChoke = GetKeyconstFromString(conf.ReadEntry("Control_Player" + keyLayout, "Choke"))
		hum.KTailHit = GetKeyconstFromString(conf.ReadEntry("Control_Player" + keyLayout, "TailHit"))
		hum.KBiteAttack = GetKeyconstFromString(conf.ReadEntry("Control_Player" + keyLayout, "BiteAttack"))
		hum.lives = start_lives
		
		Return hum
	End Function
	
	Function AddAI:TAISpieler(staerke:Int = 0, color:Float[] = Null)
		Local AI:TAISpieler = New TAISpieler
		AI.index = TSpieler.indices + 1
		TSpieler.indices:+1
		If color <> Null Then
			AI.color = color
		End If
		
		AI.schlange = TSnakeLiving.Create(5, Rand(64, SekPixelSize - 64), Rand(64, SekPixelSize - 64), AI, -1000, AI.aussehen, AI.color)
'		AI.schlange.owner = AI.index
		ai.schlange.color = ai.color
		ai.lives = start_lives
		Return AI
	End Function
	
	Method SimpelCollision:Int(Posx:Float, posy:Float, ssize:Float, collX:Float ptr, collY:Float ptr)
		'Kugel gegen Wand?
		collX[0] = 0
		collY[0] = 0
'		For Local wand:TWand = EachIn Waende
'			If wand.CheckCollision(Posx, posy, ssize) = 1 Then
'				Return - 1 '1 -> nicht fressbar (wand etc)
'			EndIf
'		Next 'Hierhin kams? Also nein!
		
		'Kugel gegen spieler? :)
		For Local player:TSpieler = EachIn Mitspieler
			If player.schlange Then
			If player.index <> Self.index Then
				If Pixelweg(player.schlange.Posx, player.schlange.posy, Posx, posy) < (8 + ssize) * 4 Then
					If pyth(player.schlange.Posx, player.schlange.posy, Posx, posy) <= (ssize + 8 - 2) Then
						collX[0] = player.schlange.Posx
						collY[0] = player.schlange.posy
						Return 2 'fressbar! Notfalls - mampf!
					EndIf
				End If
			EndIf
			For Local part:TSnakePart = EachIn player.schlange.parts
				If Pixelweg(part.Posx, part.posy, Posx, posy) < (8 + part.ssize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(part.Posx, part.posy, Posx, posy) <= (part.ssize + 8 - 2) Then
						If player.index = Self.index Then
							collX[0] = part.Posx
							collY[0] = part.posy
							Return 1 'index für wand -> eigene parts nicht fressbar!
						EndIf
						Return 2 'fressbar! notfalls - mampf!
					End If
				EndIf
			Next
			EndIf
		Next
		'Verrottende schlangen hier?
		For Local rottenSnake:TSnake = EachIn rottenSnakes
			If rottenSnake.isRottenPart = 0 And Pixelweg(rottenSnake.Posx, rottenSnake.posy, Posx, posy) < (8 + ssize) * 4 Then
				'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
				If pyth(rottenSnake.Posx, rottenSnake.posy, Posx, posy) <= (8 + ssize - 2) Then
							collX[0] = rottenSnake.Posx
							collY[0] = rottenSnake.posy
						Return 2 'fressbar! notfalls - mampf!
				End If
			EndIf
			'oh hey ich lebe noch. Gleich mal die parts abchecken.
			For Local rottenPart:TSnakePart = EachIn rottenSnake.parts
				If Pixelweg(rottenPart.Posx, rottenPart.posy, Posx, posy) < (ssize + rottenPart.ssize) * 4 Then
					'Der pixelweg ist schon gefährlich nah dran - Lieber mal den guten alten Pythagoras fragen, was er davon hält :)
					If pyth(rottenPart.Posx, rottenPart.posy, Posx, posy) <= (ssize + rottenPart.ssize - 2) Then
							collX[0] = rottenPart.Posx
							collY[0] = rottenPart.posy
					
							Return 2 'fressbar! notfalls - mampf!
			
					End If
				EndIf
			Next
		Next

		Return 0 'nix zu sehen, housten!
	End Method
	
	Method SimpelCollision_Wallcheck:Int(Posx:Float, posy:Float, ssize:Float, collX:Float ptr, collY:Float ptr)
		collX[0] = 0
		collY[0] = 0
		'Kugel gegen Wand?
		For Local wand:TWand = EachIn Waende
			If wand.CheckCollision(Posx, posy, ssize) = 1 Then
				collX[0] = wand.startX
				collY[0] = wand.startY
				Return - 1 '1 -> nicht fressbar (wand etc)
			EndIf
		Next 'Hierhin kams? Also nein!
		Return 0 'nix zu sehen, housten!
	End Method

	Method Update() Abstract
	
	Method Draw() Abstract
End Type

Type TMenschlicherSpieler Extends TSpieler
'	Field index:Int = 0
	Field KLeft:Int = 0
	Field KRight:Int = 0
	Field KChoke:Int = 0
	Field KTailHit:Int = 0
	Field KBiteAttack:Int = 0
	
	Method Update:Int()
		If Self.lives < 1 Then Return - 1
		If Self.schlange = Null Then
			Self.RespawnSnake()
			Return 0
		End If
		If Self.lives > lives_to_win Then
			menue.Win(Self.index)
		EndIf
		Local coll:Int = 0
		
		If Self.schlange.buff.Update() = -1 Then
			Self.schlange.buff = Tbuff_nothing.Create(0,0)
		End If
		
		If Self.schlange.CheckCollision(Self.schlange.ACTION.flag()) = -1 Then return 0'Self.KillSnake()
		'	Self.lives:-1
		'	If Self.lives = 0 Then
		'		RuntimeError("GAME_OVER")
		'	End If
		'	rottenSnakes.AddLast(Self.schlange)
		'	Self.schlange = TSnake.Create(5, Rand(64, SekPixelSize - 64), Rand(64, SekPixelSize - 64), Self, Self.aussehen)
	
	'		Self.schlange.owner = Self.index
		'	Self.schlange.color = Self.color
		'	Return 0
		'EndIf
		If Self.schlange Then
		If KeyDown(KBiteAttack) Then
'			Local newPart:TSnakePart = New TSnakePart
'			
'			Local tmpPart:TSnakePart = TSnakePart(Self.schlange.parts.First())
'			
'			newPart.angle = tmpPart.angle
'			newPart.posX = tmpPart.posX
'			newPart.posY = tmpPart.posY
'			
'			Self.schlange.parts.AddFirst(newPart)
'			Self.schlange.ResizeParts()
			Self.schlange.Attack()
		End If
		
		If KeyDown(KChoke) Then Self.schlange.Choke()
		If KeyDown(KTailHit) Then Self.schlange.SchwanzHieb()
	'	If KeyDown(KEY_RSHIFT) Then Self.schlange.AddPart()
		
		Local firstPart:TSnakePart = TSnakePart(Self.schlange.parts.First())
		If KeyDown(KLeft) Then
			
			Self.schlange.MOVE_Left()
		ElseIf KeyDown(KRight) Then
			
			Self.schlange.MOVE_Right()
		EndIf
		Self.schlange.Move()
		EndIf
	End Method
	
	Method Draw()
		If Self.schlange Then Self.schlange.Draw()
	End Method
End Type
Type TAIDummyPoint
	Field posx:Float
	Field posy:Float
	
	Function Create:TAIDummyPoint(posx:Float, posy:Float)
		Local point:TAIDummyPoint = New TAIDummyPoint
		
		point.posx = posx
		point.posy = posy
		
		Return point
	End Function
End Type
Type TAISpieler Extends TSpieler
'	Field index:Int = 1
	Field updateTimer:Int = MilliSecs()
	Field target:TSnake = Null
	
	Field desPoint:Float[] = Null
	
	Field try_action:Int = 0 '0 = punkt ansteuern, 1 = schlange angreifen, 2 = schlange fressen (nur rotten), 3 = part fressen, 4 = punkt meiden.
	Field victim:Object = Null
	Method New()
		Self.index = 1
	'	Self.schlange.owner = Self.index
	End Method
	
	Method Update:Int()
		If Self.lives < 1 Then Return - 1
		If Self.schlange = Null Then
			Self.RespawnSnake()
			Return 0
		End If
	'	Self.schlange.Move()
		If Self.lives > lives_to_win Then
			menue.loose(Self.index)
		End If
		If Self.schlange.buff.Update() = -1 Then
			Self.schlange.buff = Tbuff_nothing.Create(0, 0)
		End If
	
	'	If Self.victim = Null Then
			'ich habe kein opfer! Priorität auswählen.
			
			'step 1: Collisionen prüfen - meidungspunkt auswählen!
	'		Local arr:Int[] = Self.CheckNextFrames(80, 4, 10)
	'		If arr[1]
	'	End If
		
		'Gucken ob ein angriff lohnt! Ein part von ZIEL muss unmittelbar vor Self liegen!
		If Self.target = Null Or Self.target.isKilled = 1 Then
'			Local trys:Int = 0
'			While 1
'				trys:+1
'				Local tmpRnd:Int = Rand(0, Mitspieler.Count() - 1)
'				If TSpieler(Mitspieler.ValueAtIndex(tmpRnd)).index <> Self.index Then
'					Self.target = TSpieler(Mitspieler.ValueAtIndex(tmpRnd)).schlange
'					Exit
'				End If
'				If trys > 4 Then Exit
'
'			Wend
			Self.target = GetVictim(Self.schlange)
			
		Else
			Local nextTarget:TSnake = GetVictim(Self.schlange, Abstand(Self.schlange.posX, Self.schlange.posY, Self.target.posX, Self.target.posy))
			If nextTarget <> Null Then Self.target = nextTarget
		End If
'		For Local wall:TWand = EachIn Waende
'			If wall.CheckCollision(Self.schlange.posX, Self.schlange.posY, 8) = 1 Then
'				Print "Lauf forest, laaauf! Ouch, donnet vor die wand :3"
'				Self.KillSnake()
'			End If
'		Next
		
		Local zielX:Float = Self.schlange.posX + Cos(Self.schlange.angle)
		
		Local zielY:Float = Self.schlange.posX + Sin(Self.schlange.angle)
		If Self.target Then
			zielY = Self.target.posy
			zielX = Self.target.posx
		End If
		
'		If pyth(zielX, zielY, Self.schlange.posX, Self.schlange.posy) < 30 And Self.schlange.NewActionPossible() Then
'			Self.schlange.Attack()
'			Print "Es ist in reichweite. ANGRIFF"
'		ElseIf pyth(zielX, zielY, Self.schlange.posX, Self.schlange.posy) > 300 Then
'			Self.target = Null
'			zielX = Rnd(64, SekPixelSize)
'			zielY = Rnd(64, SekPixelSize)
'		End If

		Local collCheck:Float[] = Self.CheckNextFrames(80, 4, 10)
		Self.schlange.angle:+45
		Local collcheck2:Float[] = Self.checknextframes(50, 4, 10)
		Self.schlange.angle:-90
		Local collcheck3:Float[] = Self.CheckNextFrames(50, 4, 10)
		Self.schlange.angle:+45
		
		If collCheck = Null And collcheck2 = Null And collcheck3 = Null Then

			Local Zielwinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, zielX, zielY, Self.schlange.angle)
	'		
			If Zielwinkel > 5 Then
				Self.schlange.MOVE_RIGHT
			ElseIf Zielwinkel < - 5 Then
				Self.schlange.MOVE_LEFT
			Else
				'ich guck drauf zu! evlt choken! :)
				If Self.target And Self.target.isKilled = 0 Then
				If pyth(Self.schlange.posX, Self.schlange.posY, zielX, zielY) > 100 Then
				If Self.schlange.laenge > 2 And Self.schlange.laenge < 12 Then
					Select Rand(0, 10)
						Case 0 Self.schlange.choke()
					End Select
				End If
				EndIf
				EndIf
			End If
		'vorn + richtung = kollision
		ElseIf collCheck And collcheck2 And collcheck3 = Null And Abs(collCheck[3]) = 1 And Abs(collcheck2[3]) = 1 Then
			Self.schlange.move_left()
		ElseIf collCheck And collcheck3 And collcheck2 = Null And Abs(collCheck[3]) = 1 And Abs(collcheck3[3]) = 1 Then
			Self.schlange.MOVE_Right()
		
		'Angriff in richtung!
		ElseIf collCheck And collcheck2 = Null And collcheck3 = Null And collCheck[3] = 2 And Self.schlange.NewActionPossible() = 1 Then
		'	Print "Sonderfall - Angriff vorn!"
		
			Self.schlange.attack()
		ElseIf collCheck = Null And collcheck2 And collcheck3 = Null And collcheck2[3] = 2 And Self.schlange.NewActionPossible() = 1 Then
		'	Print "Sonderfall - angriff nach rechts"
			Self.schlange.Attack()
			Self.schlange.MOVE_Right()
		ElseIf collCheck = Null And collcheck2 = Null And collcheck3 And collcheck3[3] = 2 And Self.schlange.NewActionPossible() = 1 Then
		'	Print "Sonderfall - angriff nach links"
			Self.schlange.Attack()
			Self.schlange.MOVE_Left()
		
		'Angriff mit ausweichen links oder rechts
		ElseIf collcheck2 And collcheck3 = Null And collCheck And collCheck[3] = 2 And Self.schlange.NewActionPossible() = 1 Then
			'Sonderfall! 
			'rechts gibts kolli, vorn gibts kolli. vorn ist fressbar, aber links ist frei -> angriff und links ausweichen!
		'	Print "SONDERFALL1"
			Self.schlange.Attack()
			Self.schlange.MOVE_Left()
		ElseIf collcheck3 And collcheck2 = Null And collCheck And collCheck[3] = 2 And Self.schlange.NewActionPossible() = 1 Then
			'Sonderfall! 
			'links gibts kolli, vorn gibts kolli. vorn ist fressbar, aber rechts ist frei -> angriff und rechts ausweichen!
		'	Print "SONDERFALL2"
			Self.schlange.Attack()
			Self.schlange.MOVE_Right()
		
		'Angriff läuft, also draufhalten
		ElseIf collCheck <> Null And (collCheck[3] = 2 And Self.schlange.ACTION.Flag() = 1) And Self.schlange.ACTION.endTime - ms > 500 Then
			'Draufhalten ;)
			Local Zielwinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, collCheck[1], collCheck[2], Self.schlange.angle)
		'	Print "Kein weg führt weg :<"
			If Zielwinkel > 3 Then
				Self.schlange.MOVE_RIGHT
			ElseIf Zielwinkel < - 3
				Self.schlange.MOVE_LEFT
			End If
		'	Print "draufhalten "
		'	Print "Draufbeißen und draufhalten :)"
		ElseIf collcheck2 <> Null And (collcheck2[3] = 2 And Self.schlange.ACTION.Flag() = 1) And Self.schlange.ACTION.endTime - ms > 500 Then
			Local Zielwinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, collCheck2[1], collCheck2[2], Self.schlange.angle)
		'	Print "Kein weg führt weg :<"
			If Zielwinkel > 3 Then
				Self.schlange.MOVE_RIGHT
			ElseIf Zielwinkel < - 3
				Self.schlange.MOVE_LEFT
			End If
		' Print "draufhalten -45
		ElseIf collcheck3 <> Null And (collcheck3[3] = 2 And Self.schlange.ACTION.Flag() = 1) And Self.schlange.ACTION.endTime - ms > 500 Then
			Local Zielwinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, collCheck3[1], collCheck3[2], Self.schlange.angle)
		'	Print "Kein weg führt weg :<"
			If Zielwinkel > 3 Then
				Self.schlange.MOVE_RIGHT
			ElseIf Zielwinkel < - 3
				Self.schlange.MOVE_LEFT
			End If
		'	Print "draufhalten -45"
		
		'Ausweichen
		ElseIf collcheck2 <> Null Then
			If Self.schlange And (collcheck2[3] = 2 And Self.schlange.NewActionPossible() = 0) Or Abs(collcheck2[3]) = 1  'nix mit fressen!
				'ausweichpunkt bestimmen! :D
			'	Local collWinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, collCheck2[1], collCheck2[2], Self.schlange.angle)
			'	If collWinkel < 1 Then
					Self.schlange.move_left
			'	Else
			'		Self.schlange.move_right
			'	End If
		'		Print "weg hier +45"
			EndIf
		ElseIf collcheck3 <> Null Then
			If Self.schlange And (collcheck3[3] = 2 And Self.schlange.NewActionPossible() = 0) Or Abs(collcheck3[3]) = 1  'nix mit fressen!
				'ausweichpunkt bestimmen! :D
			'	Local collWinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, collCheck3[1], collCheck3[2], Self.schlange.angle)
			'	If collWinkel < 1 Then
			'		Self.schlange.move_left
			'	Else
					Self.schlange.move_right
			'	End If
		'		Print "weg hier +45"
			EndIf
		ElseIf collCheck <> Null
			If Self.schlange And (collCheck[3] = 2 And Self.schlange.NewActionPossible() = 0) Or Abs(collCheck[3]) = 1  'nix mit fressen!
				'ausweichpunkt bestimmen! :D
				Local collWinkel:Float = GetangleDiff(Self.schlange.posX, Self.schlange.posY, collCheck[1], collCheck[2], Self.schlange.angle)
				If collWinkel > 0 Then
					Self.schlange.move_left
				ElseIf collWinkel < 0 Then
					Self.schlange.move_right
				Else
					Select Rand(0, 1)
						Case 0 Self.schlange.MOVE_Left
						Case 1 Self.schlange.move_right
					End Select
				End If
			'	Print "weg hier gradeaus"
			EndIf
		'	Print "Weg hier :<"

		Else
			Self.schlange.Attack()
'			Print "Nix ausweichen etc, nur angriff!"
		'	Print "OMG Verteidigungsfressen!"
		EndIf
		Self.schlange.CheckCollision(Self.schlange.ACTION.Flag())
		If Self.schlange Then Self.schlange.Move()

		'Print "Diff: " + (Self.schlange.angle - winkel)
		
		
	End Method
	
	Rem
		bbdoc: Diese funktion prüft eine gewisse anzahl an frames in gleiche richtung auf collision. ~n rückgabe ist frame, wo die Collision stattfinden wird (approx) ~n Stp ist ein Stp faktor, wie genau geprüft werdne soll. 4-5 dürfte für eine brauchbares ergebnis reichen.
	
	end rem
	Method CheckNextFrames:Float[] (frameCnt:Int, ssize:Float = 8.0, stp:Int = 1)
		Local retArr:Float[] = New Float[4]
		Local tmpX:Float = Self.schlange.posx
		Local tmpY:Float = Self.schlange.posy
		If stp > 0 Then stp = stp - 1
		If stp < 0 Then stp = 0
	
'		glColor4f(1.0, 0, 0, 0.4)

		Local collX:Float = 0
		Local collY:Float = 0

		For Local i:Int = 6 To frameCnt - 6
			
			tmpX = Self.schlange.posx + Cos(Self.schlange.angle) * i
			tmpY = Self.schlange.posy + Sin(Self.schlange.angle) * i
			i:+stp
			ssize:+3
'			glPushMatrix()
'		'	glTranslated(tmpX, tmpY, 0)
'		'	If i > frameCnt - 4 Then
'				glColor4f(1, 0.0, 0, 0.1)
''			Else
''				glColor4f(1, 0.0, 0, 0.1)
''			EndIf
'			glBegin(GL_TRIANGLE_FAN)
'				glTexCoord2d(Snake_u / 2.0, Snake_v / 2.0)
'				glVertex2d(tmpX, tmpY) 'v1
'			'	Print "HUHU"
'				For Local tmpAngle:Int = 0 To 360 Step 36
'					glVertex2d(tmpX + Cos(tmpAngle) * ssize, tmpY + Sin(tmpAngle) * ssize) 'vX
'				Next
'			glEnd()
'			glPopMatrix()
			Local collWall:Int = Self.SimpelCollision_Wallcheck(tmpx, tmpy, ssize, VarPtr(collX), VarPtr(colly))
			If collWall = -1 Then
				'kollision!
				retArr[0] = i
				retArr[1] = (tmpX + collX) / 2
				retArr[2] = (tmpY + collY) / 2
				retArr[3] = collWall
				Return retArr
			End If
			Local collType:Int = Self.SimpelCollision(tmpx, tmpy, ssize, VarPtr(collX), VarPtr(colly))
			If collType > 0 Then
				retArr[0] = i
				retArr[1] = (tmpX + collX) / 2
				retArr[2] = (tmpY + collY) / 2
				retArr[3] = collType
				Return retArr
			Else
				
			EndIf
		Next
		Return Null
	End Method
	
	Method CheckWallCollision:Float[] ()
		
	End Method
	
	Method Draw()
		If Self.schlange Then Self.schlange.Draw()

	End Method
	
End Type